var bSerachMode = false;
var bPrintMode = false;
var directObjectSearchFlag = false;
var bFullset = null;

function linkTo(href)
{
	location.href = href;
}


function directSearch(div)
{
	if (bSerachMode || bPrintMode) {
		linkTo('adica:direct_search/' + div.id);
	}
}

function directSearchID(id)
{
	if (bSerachMode || bPrintMode) {
		linkTo('adica:direct_search/' + id);
	}
}

function directSearchOver(div)
{
	if (bSerachMode) {
		if (typeof(div) == "string"){
			linkTo('adica:direct_search_over/' + div);
		} else {
			linkTo('adica:direct_search_over/' + div.id);
		}
	}
}

function directSearchOut(div)
{
	if (bSerachMode) {
		if (typeof(div) == "string"){
			linkTo('adica:direct_search_out/' + div);
		} else {
			linkTo('adica:direct_search_out/' + div.id);
		}
	}
}

function directObjectSearch(div)
{
	if (bSerachMode) {
		directObjectSearchFlag = true;
		linkTo('adica:direct_search/' + div.id);
	}
}

function directSearchText(text)
{
	if (bSerachMode) {
		linkTo('adica:direct_search_text/' + text);
	}
}


function setSerachMode(mode)
{
	if (mode == "true") {
		bSerachMode = true;
	} else {
		bSerachMode = false;
	}
}

function setPrintMode(mode)
{
	if (mode == "true") {
		bPrintMode = true;
	} else {
		bPrintMode = false;
	}
}




var bInputMode = false;

function getSelectText()
{
	var text = "";
	if (!bInputMode) {
		text = document.selection.createRange().text;
	}
	return text;
}


function textSearchCheck() 
{
	var text = getSelectText();
	if (text && text != "") {
		directSearchText(text);
		return true;
	}
	return false;
}


var popupArray = new Array();
var popNowArray = new Array();

function popupOn(x, y, box, sizeX, sizeY, refID) 
{
	if (x < 0 || y < 0) {
		var viewMaxY = - document.body.scrollTop + document.body.clientHeight;
		var viewMaxX = - document.body.scrollLeft + document.body.clientWidth;
		x = event.x;
		y = event.y;

		if (popupArray[refID] == null) {
			popupArray[refID] = 0;
		}
		if (popupArray[refID] != null) {
			sizeY = popupArray[refID];
			var boxH = parseInt(box.style.height);
			if (boxH && boxH != 0) {
				popupArray[refID] += boxH;
			} else {
				boxH = 0;
				if (box.style.fontSize) {
					boxH += parseInt(box.style.fontSize);
				}
				if (box.style.borderWidth) {
					boxH += parseInt(box.style.borderWidth) * 2;
				}
				if (boxH == 0) {
					boxH += 25;
				}
				popupArray[refID] += boxH;
			}
		}

		if (sizeY != 0 && viewMaxY > sizeY) {
			y = y + sizeY;
			if (y < 0) {
				y = 0;
			}
		}
		if (sizeX != 0 && viewMaxX > sizeX ) {
			x = x + sizeX;
			if (x < 0) {
				x = 0;
			}
		}
	}

	if (navigator.userAgent.indexOf("MSIE 4.") >= 0) {
		box.style.left = x + 10;
		box.style.top = y + 10;
		box.style.visibility = "visible";
	} 
	else if(navigator.userAgent.indexOf("MSIE 5.") >= 0 || navigator.userAgent.indexOf("MSIE 6.") >= 0) {
		box.style.left = document.body.scrollLeft + x + 10;
		box.style.top = document.body.scrollTop + y + 10;
		box.style.visibility = "visible";
	} 
	else if(document.layers) {
		document.box.left = x + 10;
		document.box.top = y + 10;
	}
}


function popupOff(box, refID) 
{
	if (popupArray[refID] != null) {
		popupArray[refID] = 0;
	}

	if (navigator.userAgent.indexOf("MSIE 4.") >= 0){
		box.style.visibility = "hidden";
	}
	else if (navigator.userAgent.indexOf("MSIE 5.") >= 0 || navigator.userAgent.indexOf("MSIE 6.") >= 0) {
		box.style.visibility = "hidden";
	}
	else if (document.layers) {
		document.box.left = -100;
		document.box.top = -100;
	}
}



function getSegmentTime(id)
{
	var video = document.getElementById(id + "_animationMainTime");
	if (video != null && video.currTimeState.isActive) {
		return video.currTimeState.segmentTime;
	}
	return 0;
}


function setCurrentToCookie(id)
{
	setCookie("CurrentPageID",id);
}


function setCookie(key, val, tmp) 
{
	tmp = key + "=" + escape(val) + "; ";
	tmp += "expires=Fri, 31-Dec-2030 23:59:59; ";
	document.cookie = tmp;
}


function setNewHistToCookie(manualPath, manualName, pageID, pageName, pageText)
{
	setCookie("HistoryUpdateManualTitle", manualName);
	setCookie("HistoryUpdateManualPath", manualPath);
	setCookie("HistoryUpdatePageTitle", pageName);
	setCookie("HistoryUpdatePageID", pageID);
	setCookie("HistoryUpdateText", pageText);
	setCookie("HistoryUpdate","Add");
}



function animate(ani, targetID, attributeName, dur, from, to)
{
	var targetElement = document.getElementById(targetID);
	if (targetElement == null) {
		return;
	}
	if (bFullset != null && bFullset == targetID) {
		return;
	}

	if (from == 'current') {
		if (attributeName == 'top') {
			ani.from = targetElement.offsetTop;
		}
		if (attributeName == 'left') {
			ani.from = targetElement.offsetLeft;
		}
		if (attributeName == 'width') {
			ani.from = targetElement.offsetWidth;
		}
		if (attributeName == 'height') {
			ani.from = targetElement.offsetHeight;
		}
	} else {
		ani.from = from;
	}
	ani.to = to;
	ani.dur = dur;
	ani.attributeName = attributeName;
	ani.targetElement = targetID;
}


function animateSVG(ani, targetID, attributeName, dur, from, to)
{
	var targetElement = document.getElementById(targetID);
	if (targetElement == null) {
		return;
	}
	if (bFullset != null && bFullset == targetID) {
		return;
	}

	if (from == 'current') {
		if (attributeName == 'top') {
			ani.from = targetElement.offsetTop;
		}
		if (attributeName == 'left') {
			ani.from = targetElement.offsetLeft;
		}
		if (attributeName == 'width') {
			ani.from = targetElement.offsetWidth;
		}
		if (attributeName == 'height') {
			ani.from = targetElement.offsetHeight;
		}
	} else {
		ani.from = from;
	}
	ani.to = to;
	ani.dur = dur;
	ani.attributeName = attributeName;
	ani.targetElement = targetID + '_svg';
}


function htSet(set, targetElement, attributeName, to)
{
	set.targetElement = targetElement;
	set.attributeName = attributeName;
	set.to = to;
}



function appendFusenDiv(pare, fusen)
{
	pare.appendChild(fusen);
	fusen.style.left = '100%';
	fusen.style.top = '0'; 
}


function disappendFusenDiv(pare, fusen)
{
	document.body.appendChild(fusen);
	fusen.style.left = pare.offsetLeft + pare.offsetWidth + 1;
	fusen.style.top = pare.offsetTop;
	fusen.style.zIndex = 4;
}

function disappendFusenDivById(pareID, fusenID)
{
	if (pareID != null && fusenID != null) {
		disappendFusenDiv(pareID, fusenID);
	}
}


function fusenNonPost(pare, fusen)
{
	appendFusenDiv(pare, fusen);
	setTimeout("disappendFusenDivById(" + pare.id + "," + fusen.id + ")", 20);
}


function tranIn(div)
{
	var vis = div.getAttribute('style').visibility;
	if (div.currTimeState == null || !div.currTimeState.isActive) {
		div.beginElement();
		div.style.visibility = 'visible';
		div.style.display = 'block';
	}
}

function tranIn2(tran, div)
{
	var vis = div.getAttribute('style').visibility;
	if (div.currTimeState.isActive || (vis == 'visible')) {
	} else {
		tran.beginElement();
		div.style.visibility = 'visible';
		div.style.display = 'block';
		div.beginElement();
	}
}

function tranOut(div)
{
	var vis = div.getAttribute('style').visibility;
	if (div.currTimeState != null && div.currTimeState.isActive) {
		div.style.visibility = 'hidden';
		div.style.display = 'none';
		div.endElement();
	}
}
function tranOut2(tran, div)
{
	var vis = div.getAttribute('style').visibility;
	if (!div.currTimeState.isActive || vis == 'hidden') {
	} else {
		tran.beginElement();
	}
}

function tranOutAfter(div)
{
	div.style.visibility = 'hidden';
	div.style.display = 'none';
	div.endElement();
}



var overAray = new Array();

function overCheck(tran, div, inout)
{
	var vis = div.getAttribute('style').visibility;
	if (inout == 'in') {
		if (div.currTimeState.isActive || (vis == 'visible')) {
		} else {
			tran.beginElement();
			div.style.visibility = 'visible';
			div.style.display = 'block';
			div.beginElement();
			overAray[div.id] = true;
		}
	} else {
		if (!div.currTimeState.isActive || vis == 'hidden') {
		} else {
			tran.beginElement();
			overAray[div.id] = true;
		}
	}
}


function overCheckAfter(div, inout)
{
	var vis = div.getAttribute('style').visibility;
	if (inout == 'in') {
		if (vis == "visible" && overAray[div.id] == true) {
			div.style.visibility = 'hidden';
			div.style.display = 'none';
			div.endElement();
			overAray[div.id] = false;
		}
	} else {
		if (vis == "hidden" && overAray[div.id] == true) {
			div.style.visibility = 'visible';
			div.style.display = 'block';
			div.beginElement();
			overAray[div.id] = false;
		}
	}
}

function chDisp() 
{
	BeforeTable.style.display = "none";
	MainDiv.style.display = "block";
}




var oldZindex = -1;
var oldLeft   = -1;
var oldTop    = -1;
var oldWidth  = -1;
var oldHeight = -1;
var oldBorderWidth = -1;

function zoomtoArea(videoID, left, top, width, height, bMax)
{
	var elem = document.getElementById(videoID);
	if (elem == null || elem == undefined) {
		return;
	}

	if (bMax == 'true' && oldZindex == -1) {
		oldZindex = elem.style.zIndex;
		oldLeft   = elem.style.left;
		oldTop    = elem.style.top;
		oldWidth  = elem.style.width;
		oldHeight = elem.style.height;
		oldBorderWidth = elem.style.borderWidth;

		elem.style.zIndex = 999;
		elem.style.left   = left;
		elem.style.top    = top;
		elem.style.width  = width;
		elem.style.height = height;
		elem.style.borderWidth = 0;

		document.body.scroll = 'no';
		bFullset = videoID;
	} 
	else if (bMax == 'false' && oldZindex != -1) {
		elem.style.zIndex = oldZindex;
		elem.style.left   = oldLeft;
		elem.style.top    = oldTop;
		elem.style.width  = oldWidth;
		elem.style.height = oldHeight;
		elem.style.borderWidth = oldBorderWidth;

		oldZindex = -1;
		oldLeft   = -1;
		oldTop    = -1;
		oldWidth  = -1;
		oldHeight = -1;
		oldBorderWidth = -1;

		document.body.scroll = 'yes';
		bFullset = null;
	}
}


function displayArea(videoID, bDisp)
{
	var elem = document.getElementById(videoID);
	if (elem == null || elem == undefined) {
		return;
	}

	if (bDisp == 'true') {
		elem.style.display = 'block';
	} else {
		elem.style.display = 'none';
	}
}

function linkEvent(href) 
{
	linkTo(href);
}



