var debugStartX = 0;
var debugStartY = 0;

var docMouseMove = null;
var docMouseUp = null;
var debugGrabObj = null;

function debugMouseDown(e){
	debugStartX =  document.body.scrollLeft+event.clientX;
 	debugStartY =  document.body.scrollTop+event.clientY;
	debugGrabObj = e;

	if(debugGrabObj){
		docMouseMove = document.onmousemove;
		docMouseUp = document.onmouseup;
		document.onmousemove=debugMouseMove;
   		document.onmouseup=debugMouseUp;
	}
	return false;
}


function debugMouseMove(){
	curX =  document.body.scrollLeft+event.clientX;
 	curY =  document.body.scrollTop+event.clientY;
	dx=curX-debugStartX; dy=curY-debugStartY;
	if(debugGrabObj){
	  if(curX!=debugStartX||curY!=debugStartY){
      	debugGrabObj.style.pixelLeft=debugGrabObj.offsetLeft+dx+0.5;
      	debugGrabObj.style.pixelTop=debugGrabObj.offsetTop+dy+0.5;
	  }
		debugStartX=curX;
		debugStartY=curY;
	}
	return false;
}

function debugMouseUp(){
	if(debugGrabObj){
		document.onmousemove=docMouseMove;
		document.onmouseup = docMouseUp;
		debugGrabObj = null;	
	}
}


function logIt(evt, num)
{
	var val = 0;
	var mainWin = document.getElementById("debugWindow");
	if(!mainWin) return;


	if(typeof(num)!="undefined"){
		val = num;
	}
	str = "debugW" + val;

	dw = document.getElementById(str);
	if(dw){
		dw.innerHTML += evt + '<br/>';
		dw.doScroll("scrollbarPageDown");
	}else{
		var newButton = document.createElement("button");
		newButton.innerHTML ="Clear";
		newButton.attachEvent("onclick", clearForm); 
		newButton.setAttribute("id2",str);

		var newButton2 = document.createElement("button");
		newButton2.innerHTML ="Hide";
		newButton2.attachEvent("onclick", toggleDebug); 
		newButton2.setAttribute("id2",str);

		mainWin.appendChild(newButton);
		mainWin.appendChild(newButton2);
		
		var newDebug = document.createElement("div");
		newDebug.setAttribute("id", str);
		newDebug.className="debugWin";
		mainWin.appendChild(newDebug);
		newDebug.innerHTML += evt + '<br/>';
	}
}

function clearForm(evt){
	elem = window.event.srcElement;
	str = elem.id2;
	dw = document.getElementById(str);
	if(dw){
		dw.innerHTML ="";
	}
}

function toggleDebug(evt){
	elem = window.event.srcElement;
	str = elem.id2;
	dw = document.getElementById(str);
	if(dw){
		if(dw.style.display == "none"){
			dw.style.display = "block";
			elem.innerHTML = "Hide";
		}else{
			dw.style.display = "none";
			elem.innerHTML = "Show";
		}
	}
}
