function mouseOverDiv(div, left, top){
	xLimit=false;
	yLimit=false;
	if(div == null) return false;

	if((left>=findPosX(div)) && (left <=findPosX(div)+ div.offsetWidth)){
		xLimit=true;
	}
	if((top>= findPosY(div)) && (top <=  findPosY(div) + div.offsetHeight)){
		yLimit=true;
	}
	if(xLimit && yLimit){
		return true;
	}else{
		return false;
	}
}

function findPosX(obj)
{
	var curleft = 0;
	if (obj.offsetParent)
	{
		while (obj.offsetParent)
		{
			curleft += obj.offsetLeft
			obj = obj.offsetParent;
		}
	}
	else if (obj.x)
		curleft += obj.x;
	return curleft;
}

function findPosY(obj)
{
	var curtop = 0;
	if (obj.offsetParent)
	{
		while (obj.offsetParent)
		{
			curtop += obj.offsetTop
			obj = obj.offsetParent;
		}
	}
	else if (obj.y)
		curtop += obj.y;
	return curtop;
}

function getVidID(obj){
	var arrayName = obj.id.split('_');
	return arrayName[0];
}

function getVideo(obj){
}


grabObj = null;
source = null;
spaceTag = null;
bOverTrash = false;

function spaceOver(spacetag){
	spaceTag = spacetag;
	if(spaceTag && grabObj){
		spaceTag.style.backgroundColor = "red";
	}
}

function spaceOut(spacetag){
	if(spaceTag && grabObj){
		spaceTag.style.backgroundColor = "transparent";
	}
	spaceTag = null;
}


function checkSpaces(xpos, ypos)
{
	listing = document.getElementById("favList");
	childList = listing.childNodes;
	for(var i=0; i<childList.length; i++){
		var node = childList(i);
		if ((node.className == "spacer")&&(mouseOverDiv(node, xpos, ypos))) {
			node.style.backgroundColor = "red";
			spaceTag = node;
		}else{
			node.style.backgroundColor = "transparent";
		}
	}
	
	box = document.getElementById("trashbox");
	if(mouseOverDiv(box, xpos, ypos)){
		box.style.backgroundColor = "red";
		bOverTrash = true;
	}else{
		box.style.backgroundColor = "transparent";
		bOverTrash = false;
	}
}




var mouseClickChance = false;

function mouseDown(e)
{
	startX =  document.body.scrollLeft + event.clientX;
 	startY =  document.body.scrollTop + event.clientY;
	source = e;
	grabObj = document.getElementById("cam");
	grabObj.innerHTML = source.innerHTML;

    grabObj.style.pixelWidth = source.offsetWidth;
    grabObj.style.pixelHeight = source.offsetHeight;
	
	if (grabObj){
		grabObj.style.display = "block";
		grabObj.filters.alpha.opacity = 60;
		grabObj.style.zoom = 0.4;
      	grabObj.style.pixelLeft=startX - 10;
      	grabObj.style.pixelTop=startY - 10;

		document.onmousemove = mouseMove;
   		document.onmouseup = mouseUp;
		mouseClickChance = true;
		setTimeout("mouseClickTiming()",400);
	}
}

function mouseClickTiming(){
	mouseClickChance = false;
}

function mouseMove()
{
	curX = document.body.scrollLeft + event.clientX;
	curY = document.body.scrollTop + event.clientY;
	dx = curX - startX; 
	dy = curY - startY;

	if (grabObj) {
		if (curX != startX || curY != startY) {
			grabObj.style.pixelLeft = grabObj.offsetLeft + dx + 0.5;
			grabObj.style.pixelTop = grabObj.offsetTop + dy + 0.5;
			mouseClickChance = false;
		}
		checkSpaces(curX,curY);
	}
	startX = curX; 
	startY = curY;
	
	return false;
}

function mouseClickToLink() {
	vidid = getVidID(source);
	sourceSpace = document.getElementById(vidid + "_space");
	if (sourceSpace) {
		linkTo(sourceSpace.unicoLink);
	}
}


function mouseUp()
{
	if (mouseClickChance) {
		grabObj.style.display = "none";
		grabObj = null;
		document.onmousemove= null;
   		document.onmouseup  = null;
		mouseClickChance = false;
		mouseClickToLink();
		return;
	}

	vidid = getVidID(source);
	sourceSpace = document.getElementById(vidid + "_space");
	var fromInfo;
	var toInfo;

	if(spaceTag){
		if(getVidID(spaceTag) != vidid){
			listing = document.getElementById("favList");
			
			var sourcePos, spacePos;
			for (sourcePos = 0; sourcePos < favList.childNodes.length; sourcePos++) {
				if (favList.childNodes.item(sourcePos).id == sourceSpace.id) {
					break;
				}
			}
			for (spacePos = 0; spacePos < favList.childNodes.length; spacePos++) {
				if (favList.childNodes.item(spacePos).id == spaceTag.id) {
					break;
				}				
			}
			if (sourcePos > spacePos) {
				listing.insertBefore(sourceSpace, spaceTag);
			} else {
				var frontDiv = null;
				if (spacePos + 1 < favList.childNodes.length) {
					frontDiv = favList.childNodes.item(spacePos+1);
				}
				listing.insertBefore(sourceSpace, frontDiv);
			}
			linkTo('adica:fav_move/' + sourcePos + '?' + spacePos);
		}
		spaceTag.style.backgroundColor = "transparent";
		spaceTag = null;
	}

	if(bOverTrash){
		var sourcePos;
		for (sourcePos = 0; sourcePos < favList.childNodes.length; sourcePos++) {
			if (favList.childNodes.item(sourcePos).id == sourceSpace.id) {
				break;
			}
		}
		sourceSpace.removeNode(true);
		box = document.getElementById("trashbox");
		box.style.backgroundColor = "transparent";
		bOverTrash = false;
		linkTo('adica:fav_move/' + sourcePos + '?-1');
	}
	if(grabObj){
		grabObj.style.display = "none";
		grabObj = null;
		document.onmousemove= null;
   		document.onmouseup  = null;
	}
}


function linkTo(href) {
 location.href=href;
}

