var MANUAL_NAME = "";


_bro = (window.opera ? 4 : (document.all ? 3 : (document.getElementById ? 1 : (document.layers ? 2 : 0))));
_ie5 = (navigator.appName.indexOf('Microsoft Internet Explorer') >= 0 && document.getElementById) ? true : false;
_mac = navigator.userAgent.indexOf('Mac') >= 0;


function getDivFromName(nm)
{
	if (_bro == 1 || _bro == 4) {
		return document.getElementById(nm);
	}
	if (_bro == 2) {
		var s='';
		for(var i=1; i<arguments.length; i++)
			s += 'document.layers.' + arguments[i] + '.';
			return eval(s+'document.layers.'+nm);
	}
	if (_bro == 3) {
		return _ie5 ? document.getElementById(nm) : document.all(nm);
	}
	return null;
}


function getDivImage(div,imgName)
{
	if (_bro==1||_bro==4) return document.getElementById(imgName);
	if (_bro==2) return div.document.images[imgName];
	if (_bro==3) return document.images(imgName);
	return null;
}

function getDivLeft(div)
{
	if(_bro==1||_bro==4) return div.offsetLeft;   
	if(_bro==2) return div.left;
	if(_bro==3) return _ie5?div.offsetLeft:div.style.pixelLeft;
	return 0;
}

function getDivTop(div)
{
	if(_bro==1||_bro==4) return div.offsetTop;
	if(_bro==2) return div.top;
	if(_bro==3) return _ie5?div.offsetTop:div.style.pixelTop;
	return 0;
}

function moveDivTo(div,left,top)
{
	if (_bro == 1 || _bro == 4) { 
		div.style.left = left + 'px';
		div.style.top = top + 'px';
		return;
	}
	if (_bro == 2) {
		div.moveTo(left,top);
		return;
	}
	if (_bro == 3) {
		div.style.pixelLeft = left;
		div.style.pixelTop = top;
		return;
	}
}


function moveDivBy(div, left, top)
{
	var bLimit = true;

	if (_bro==1||_bro==4) {
		div.style.left = parseInt(div.style.left) + left;
		div.style.top = parseInt(div.style.top ) + top;

		if (div.style.left < 0) {
			div.style.left = 0;
			bLimit = false;
		}
		if (div.style.top < 0) {
			div.style.top = 0;
			bLimit = false;
		}
		return bLimit;
	}
	if (_bro==2) { 
		div.moveBy(left,top); 
		return bLimit; 
	}
	if (_bro==3) {
		if(_ie5){
			div.style.pixelLeft = div.offsetLeft + left + 0.5;
			div.style.pixelTop = div.offsetTop + top + 0.5;

			if (div.style.pixelLeft < 0) {
				div.style.left = 0;
				bLimit = false;
			} 
			if (div.style.pixelTop < 0) {
				div.style.top = 0;
				bLimit = false;
			}
		} else  {
			div.style.pixelLeft += left + 0.5;
			div.style.pixelTop += top + 0.5;

			if (div.style.pixelLeft < 0) {
				div.style.left = 0;
				bLimit = false;
			}
			if (div.style.pixelTop < 0) {
				div.style.top = 0;
				bLimit = false;
			}
		}

		return bLimit;
	}

	return bLimit;
}


function initDivSize(div)
{
	if (_bro==1) {
		div.style.width =div.offsetWidth +'px';
		div.style.height=div.offsetHeight+'px';
	}
	else if(_bro==3 || _bro==4) {
		div.style.pixelWidth =div.offsetWidth;
		div.style.pixelHeight=div.offsetHeight;
	}
}

function getDivWidth (div)
{
	if(_bro==1||_bro==4) return div.offsetWidth;  
	if(_bro==2) return div.clip.width;
	if(_bro==3) return _ie5?div.offsetWidth:div.style.pixelWidth;
	return 0;
}

function getDivHeight(div)
{
	if(_bro==1||_bro==4) return div.offsetHeight;
	if(_bro==2) return div.clip.height;
	if(_bro==3) return _ie5?div.offsetHeight:div.style.pixelHeight;
	return 0;
}

function setDivVisibility(div,visible)
{
	if (_bro==1||_bro==3) { 
		div.style.visibility = (visible) ? 'inherit' : 'hidden';
		return;
	}
	if (_bro==2) {
		div.visibility = (visible) ? 'inherit' : 'hide';
		return;
	}
	if (_bro==4) {
		div.style.visibility = (visible) ? 'visible' : 'hidden';
		return;
	}
}

function getEventPageX(e)
{
	if(_bro==1) return window.scrollX+e.clientX;
	if(_bro==2) return e.pageX;
	if(_bro==3) {
		b = document.body.scrollLeft+event.clientX;
		return document.body.scrollLeft+event.clientX;
	}
	if(_bro==4) return (document.documentElement?pageXOffset:0)+e.clientX;
	return 0;
}

function getEventPageY(e)
{
	if(_bro==1) return window.scrollY + e.clientY;
	if(_bro==2) return e.pageY;
	if(_bro==3) return document.body.scrollTop + event.clientY;
	if(_bro==4) return (document.documentElement ? pageYOffset : 0) + e.clientY;
	return 0;
}



function findPosX(obj)
{
	var curleft = 0;

	if (obj.offsetParent) {
		while (obj.offsetParent) {
			curleft += obj.offsetLeft
			obj = obj.offsetParent;
		}
	}
	else if (obj.x) {
		curleft += obj.x;
	}

	return curleft;
}

function findPosY(obj)
{
	var curtop = 0;

	if (obj.offsetParent) {
		while (obj.offsetParent) {
			curtop += obj.offsetTop
			obj = obj.offsetParent;
		}
	}
	else if (obj.y) {
		curtop += obj.y;
	}

	return curtop;
}


function getDragDiv(element){
	if (element.className == "dragDiv") {
		return element;
	} else {
		return getDragDiv(element.parentNode);
	}
}




timerEnd = true;
grabObj = null;

var m_clickTimer = null;

function mouseDown(e)
{
	startX = getEventPageX(e); 
	startY = getEventPageY(e);
	timeClick = 0;

	timerEnd = false;
	if (m_clickTimer != null) {
		clearTimeout(m_clickTimer);
		m_clickTimer = null;
	}
	m_clickTimer = setTimeout("timerEnd=true", 200);

	if ((e != null) && (e.id == "tabHomeTitleBar")){
		grabObj = e;
		document.onmousemove = mouseMove;
		document.onmouseup = mouseUp;
		return false;
	}

	if (window.event.srcElement.parentNode.id == "garbage"){
		grabObj = e;
	} else {
		grabObj = getDragDiv(window.event.srcElement);
	}

	if (_bro==2) {
		document.captureEvents(Event.MOUSEMOVE|Event.MOUSEUP);
	}
	if (_bro==1) {
		document.addEventListener('mousemove', mouseMove, true);
		document.addEventListener('mouseup', mouseUp, true);
	} else {
		document.onmousemove = mouseMove;
		document.onmouseup   = mouseUp;
	}

	return false; 
}


function getTagInt(tagObj){
	var str = tagObj.id.substr(3, tagObj.id.length);
	return parseInt(str);
}


function getTagDivId(tagObj){
	var number = getTagInt(tagObj);
	if (isTwin(tagObj)) {
		return tagTwinDivArr[number];
	} else {
		return tagDivArr[number];
	}
}


function setTagDivId(tagObj, value){
	var number = getTagInt(tagObj);
	if (isTwin(tagObj)) {
		tagTwinDivArr[number] = value;
	} else {
		tagDivArr[number] = value;
	}
}



function transferText(tagID)
{
	var tagObj = document.getElementById(tagID);
	var prevBox = document.getElementById("inputBox" + tagID);
	var tagname = document.getElementById("tagName" + tagID);
	var tagimg  = document.getElementById("img" + tagID);
	var bIsVid = false;
	
	if (prevBox)
	{
		var tagtxt = prevBox.value;

		var showText = changeEscapeChar(tagtxt);

		tagname.innerHTML = showText;
		tagObj.onmousedown = mouseDown;
		tagimg.onmousedown = null;

		oldTextHash[tagObj.id] = tagtxt;

		var setDiv = ((getTagDivId(tagObj) != "") && (getTagDivId(tagObj) != "float"));
		if (setDiv) 
		{
			var attachedDivId = getTagDivId(tagObj);

			if (isMovingRegion(attachedDivId) != -1) {
				updateTwin(tagObj);
				var twin = getTwin(tagObj);
				collapseTag(twin);
 			}

			if ((isVideoRegion(attachedDivId) != -1) && (isTwin(tagObj))) {
				updateTwin(tagObj);
				var twin = getTwin(tagObj);
				collapseTag(twin);
			// 2006.02.20 \ĂȂƂɕ񂪂Ȃ̂őΉ
				var tagname = getTagName(twin);
				tagname.innerHTML = tagtxt;
			}

			if (isVideoRegion(attachedDivId) != -1) {
				bIsVid = true;
				arrangeTags(document.getElementById(attachedDivId), null);
			}

			if ((isVideoRegion(attachedDivId) != -1) && (isTwin(tagObj))) {
				tagID = tagID.substr(0, tagID.length-1);
				bIsVid = false;
			}

			writeAddTagInfoToCookie(tagID, showText, tagObj.style.backgroundColor, bIsVid);
			saveFusenInfomation();
		}
	}
}



function changeEscapeChar(string)
{
	if (string == null || string == "" || string == undefined) {
		return "";
	}

	var nIndex = string.indexOf(" ", 0);
	while (nIndex != -1) {
		string = string.replace(" ", "&ensp;");
		nIndex = string.indexOf(" ", nIndex+1);
	}
	nIndex = string.indexOf("<", 0);
	while (nIndex != -1) {
		string = string.replace("<", "&lt;");
		nIndex = string.indexOf("<", nIndex+1);
	}
	nIndex = string.indexOf(">", 0);
	while (nIndex != -1) {
		string = string.replace(">", "&gt;");
		nIndex = string.indexOf(">", nIndex+1);
	}
	return string;
}



function getTwin(tagObj)
{
	if (isTwin(tagObj)) {
		var length = tagObj.id.length;
		return document.getElementById(tagObj.id.substr(0, length-1));
	} else {
		return document.getElementById(tagObj.id + "b");
	}
}



function updateTwin(tagObj)
{
	var tagNameSource = document.getElementById("tagName" + tagObj.id);
	var tagSource = tagObj;
	var tagDestination = null;

	if (isTwin(tagObj)) {
		var length = tagObj.id.length;
		tagNameDestination = document.getElementById("tagName" + tagObj.id.substr(0, length-1));
		tagDestination = document.getElementById(tagObj.id.substr(0, length-1));
	} 
	else{
		tagNameDestination = document.getElementById("tagName" + tagObj.id + "b");
		tagDestination = document.getElementById(tagObj.id + "b");
	}

	if (typeof(oldTextHash[tagObj.id]) == "undefined" || 
		oldTextHash[tagObj.id] == null || oldTextHash[tagObj.id] == "")
	{
		oldTextHash[tagObj.id] = tagNameSource.innerHTML;
	}

	if (typeof(oldTextHash[tagObj.id]) == "undefined" || oldTextHash[tagObj.id] == null) 
	{
		oldTextHash[tagDestination.id] = tagNameSource.innerHTML;
		tagNameDestination.innerHTML = tagNameSource.innerHTML;
	}
	else {
		oldTextHash[tagDestination.id] = oldTextHash[tagObj.id];
		tagNameDestination.innerHTML = oldTextHash[tagObj.id];
	}

	tagDestination.style.backgroundColor = tagSource.style.backgroundColor;
}


function mouseMove(e)
{
	if (grabObj) {
		var curX = getEventPageX(e);
		var curY = getEventPageY(e);
		var dx = curX - startX; 
		var dy = curY - startY;

		if (timerEnd != true) {
			clearTimeout(m_clickTimer);
			m_clickTimer = null;
			timerEnd = true;
		}

		if (grabObj.id == "tabHomeTitleBar") {
			grabObj = tabHome;
		}

		var createNow = false;
		if (grabObj.id == "garbage") {
			if (mouseOverDiv(grabObj, curX, curY)){
				return false;
			} else {
				grabObj = createTab();
				if (grabObj == null) {
					return false;
				} else {
					createNow = true;
				}
			}
		}

		var setDiv = false; 
		if (grabObj.className == "dragDiv") {
			setDiv = ((tagDivArr[grabObj.id.substr(3,grabObj.id.length)] != "") && (tagDivArr[grabObj.id.substr(3,grabObj.id.length)] != "float"));
			if (setDiv) {
				if (dx > -10 && dx < 10  && dy > -10 && dy < 10) { // ̂Ŗ
					return false;
				}
			}
		}

		if (curX != startX || curY != startY) {
			var bLimit = moveDivBy(grabObj, dx, dy);
			if (createNow) {
				grabObj.style.pixelLeft = curX;
				grabObj.style.pixelTop = curY;
			}
			else if (bLimit == false && grabObj == tabHome) {
				document.onmousemove = null;
				document.onmouseup   = null;
			}
		}

		startX = curX;
		startY = curY;
		if (grabObj.className == "dragDiv")
		{
			grabObj.style.position = "absolute";

			if (hasTwin(grabObj)) {
				var twin = getTwin(grabObj);
				setTagDivId(grabObj,  "");
				document.body.appendChild(twin);
				
				var vID = getTagDivId(twin);
				var vDiv = document.getElementById(vID);
				setTagDivId(twin, "");
				arrangeTags(vDiv, null);
				twin.style.display = "none";
			}

			if (setDiv) 
			{
				prevDivId = getTagDivId(grabObj);
				prevDiv = document.getElementById(prevDivId);
				if (prevDivId  != "float")
				{
					setTagDivId(grabObj,  "");
					if(prevDiv) {
						setTimeout("arrangeTags(prevDiv, null)", 50);
					}

					var prevLeft = findPosX(grabObj);
					var prevTop = findPosY(grabObj);
					var prevWidth = grabObj.parentNode.offsetWidth;

					if (isTwin(grabObj)) {
						var oldTag = grabObj;
						var twin = getTwin(grabObj);
						grabObj = twin;
						setTagDivId(grabObj, "");
						document.body.appendChild(oldTag);
						oldTag.style.display = "none";
					}

					document.body.appendChild(grabObj);
					grabObj.style.pixelLeft = prevLeft;
					grabObj.style.pixelTop = prevTop;
				}

				writeDelTagInfoToCookie(grabObj.id);
				saveFusenInfomation();
				expose(grabObj);
			}

			var home = getDivFromName("tabHome");
			if (home != null) {
				home.style.visibility = "visible";
			}

			checkTagRegions(curX, curY);
		}
	}

	return false;
}



function mouseUp(e)
{
	if (_bro==2) {
		document.releaseEvents(Event.MOUSEMOVE|Event.MOUSEUP);
	}

	if (_bro==1) {
		document.removeEventListener('mousemove', mouseMove, false);
		document.removeEventListener('mouseup', mouseUp, false);   
	} else {
		document.onmousemove = null;
		document.onmouseup   = null;
	}

	if (timerEnd != true) {
		clearTimeout(m_clickTimer);
		m_clickTimer = null;

		timerEnd = false;
		if (grabObj != null) {
			mouseClick(e);
		}
		return true;
	}

	curX = getEventPageX(e);
	curY = getEventPageY(e);

	if (grabObj != null && grabObj.className=="dragDiv" && tagDivArr[grabObj.id.substr(3,grabObj.id.length)] == ""){
		checkTagRegionsDrop(curX, curY);
		grabObj = null;
		return false;
	}

	if (grabObj != null && grabObj.className=="dragDiv" && tagDivArr[grabObj.id.substr(3,grabObj.id.length)] == "float"){
		checkTagRegionsDrop(curX, curY);
		grabObj = null;
		return false;
	}
}




var checkID = "";
var clickedDiv;

function mouseClick(e)
{
	if (grabObj.id == "tabHome" || grabObj.id == "garbage" || grabObj.id == "tabHomeTitleBar") {
		return false;
	}

	var myNumber = getTagInt(grabObj);

	var regNumber = isVideoRegion(getTagDivId(grabObj));

	if (((getTagDivId(grabObj) == "float") || (regNumber == -1)) && event != null){
		createInputBox(grabObj);
	}

	var evtTagName = "tagName" + grabObj.id;
	var evtImgName = "img" + grabObj.id;

	if (event == null) {
		appealTag(grabObj);
		if (regNumber != -1) {
			seekToTime(getTagDivId(grabObj), tagTimeArr[myNumber]);
		}
		if (hasTwin(grabObj)) {
			seekToTime(getTagDivId(getTwin(grabObj)), tagTimeArr[myNumber]);		
		}
	} 
	else if((regNumber != -1) && 
		(event.srcElement.id == evtTagName || event.srcElement.id == grabObj.id)){	//<-2005.02.22 Unico_SQE_511
		createInputBox(grabObj);	
	} 
	else if ((regNumber != -1) && (event.srcElement.id == evtImgName)){
		seekToTimeS2(getTagDivId(grabObj), tagTimeArr[myNumber]);
	}

	return false;
}




function checkKey(objid){
	if(event.keyCode == 13){
		document.body.focus();
	}
}


function createInputBox(obj)
{
	var prevBox = document.getElementById("inputBox" + obj.id);
	var tagname = document.getElementById("tagName" + obj.id);
	if (!prevBox) 
	{
		var savetxt = "";
		if (typeof(oldTextHash[obj.id]) == "undefined" || 
			oldTextHash[obj.id] == null || oldTextHash[obj.id] == "")
		{
			savetxt = tagname.innerHTML;
		} else {
			savetxt = oldTextHash[obj.id];
		}

		tagname.innerHTML = "<input type='text' onkeypress='checkKey(\"" + obj.id + "\")' onblur='transferText(\"" + obj.id + "\")' id='inputBox" + obj.id +"' size='10'>";
		var txtBox = document.getElementById("inputBox" + obj.id);
		txtBox.value = savetxt;
		txtBox.focus();
		obj.onmousedown = null;
		var img = document.getElementById("img" + obj.id);
		img.onmousedown = mouseDown;
	}
}



function mouseOverDiv(div, left, top)
{
	var xLimit = false;
	var yLimit = false;
	if (div == null) {
		return false;
	}

	if ((left >= findPosX(div)) && (left <= findPosX(div) + div.offsetWidth)) {
		xLimit = true;
	}
	if ((top >= findPosY(div)) && (top <= findPosY(div) + div.offsetHeight)) {
		yLimit = true;
	}
	if (xLimit && yLimit) {
		return true;
	} else {
		return false;
	}
}



var imgOpen = new Array();
var imgClose = new Array();
var imgDisable = new Array();
var imgTrash = new Array();
var moveTagsArr= new Array();
var activeTabs = new Array();
var tabsActiveCount =0;

var tagXpos=400;
var tagYpos=40;

var imgtag = new Image();
var startX = 0;
var startY = 0;
var currentTagRegion = null;
var grabObj = null;
var startTime = 0; 
var saveBGColor = '#fa4f24';

for (i=0; i<1; i++){
	imgOpen[i] = new Image();
	imgClose[i] = new Image();
	imgDisable[i] = new Image();
	imgTrash[i] = new Image();
}

for (i=0; i<maxTabs; i++){
	activeTabs[i]=0;
}


function initPath(path) 
{
  imgtag = path + "tab.gif";
  videotag = path + "video_icon1.gif";
  objtag   = path + "image_icon.gif";

  imgOpen[0] = path + "plus2.gif";
  imgClose[0] = path + "usual.gif";
  imgDisable[0] = path + "cross.gif";
  imgTrash[0] = path + "recycle.gif";
}




function createTab()
{
	var activateTabNum=-1;
	if (tabsActiveCount == maxTabs) {
		return null;
	}
	
	for(i=0; i<maxTabs; i++){
		if(activeTabs[i] == 0){
			activateTabNum=i;
			activeTabs[i]=1;
			tabsActiveCount++;
			return activateTab("tag"+i, getDivFromName("homeArea").style.backgroundColor, getDivFromName("tagNameInput").value);
			break;
		}
	}
	return null;
}


function createInitTab(tab, color, text)
{
	var myNumber = tab.id.substr(3, tab.id.length);
	activeTabs[myNumber] = 1;
	tabsActiveCount++;

	var div = getDivFromName(tab.id);
	if (div != null) {
		oldTextHash[div.id] = text;
		text = changeEscapeChar(text);
	}

	activateTab(tab.id, color, text);
}



function activateTab(name, color, text)
{
	div = getDivFromName(name);
	if (div == null) {
	   return null;
	}

	var tabHome = getDivFromName("tabHome");
	var tagName = document.getElementById("tagName" + div.id);

	tagName.innerHTML = text;
	div.style.display='inline';
	div.style.visibility='visible';
	div.style.pixelLeft = tabHome.offsetLeft + 10;
	div.style.pixelTop = tabHome.offsetTop + 100;
	setBGColor(color, div);
	setBGColor(color, homeArea);

	if (tabsActiveCount == maxTabs) {
		garbage.all.tags("img")[0].src = BASERESOURCE + "../fusentail#none.gif";
	}

	return div;
}

function setTimeClick()
{
	timeClick=true;
}


function checkTagRegions(left, top)
{
	var i,found;
	
	for (i=0; i<tagRegionNum; i++){
		found = checkTagRegion(eval(tagRegionArr[i]), left, top);
		if(found) {
			break;
		}
	}

	if (!found) {
	   grabObj.all.tags("img")[0].src = imgClose[0];
	}

	div = getDivFromName("tabHome");
	if (mouseOverDiv(div, left, top)) {
	   grabObj.all.tags("img")[0].src = imgTrash[0];
	}
}

function checkTagRegion(div, left, top)
{
	var overTagRegion;
	overTagRegion = mouseOverDiv(div, left, top);
	
	if (overTagRegion && div.style.visibility != 'hidden')
	{
		grabObj.all.tags("img")[0].src = imgOpen[0];

		currentTagRegion = div;
		var tagName = document.getElementById("tagName" + grabObj.id);
		tagName.style.display='inline';
		tagName.style.visibility='visible';
		
		if(checkTagExistsOnScene(div) && isVideoRegion(div.id) == -1) {
			grabObj.all.tags("img")[0].src = imgDisable[0];
		}

		return true;
	}
	else{
		if (currentTagRegion == div) {
			grabObj.all.tags("img")[0].src = imgClose[0];
			var tagName = document.getElementById("tagName" + grabObj.id);
			currentTagRegion = null;
		}
	}
	return false;
}


function checkTagRegionsDrop(left,top)
{
	var i, hit;

	var searchName = "";
	var pt = imgOpen[0].lastIndexOf("/");
	if (pt != -1) {
		var ln = imgOpen[0].length;
		searchName = imgOpen[0].substring(pt, ln);
	}

	var grabPath = grabObj.all.tags("img")[0].src;
	if (grabPath.indexOf(searchName) != -1)
	{
		if (!mouseOverDiv(getDivFromName("tabHome"), left, top)) {
			for(i=0; i<tagRegionNum; i++){
				hit = checkTagRegionDrop(eval(tagRegionArr[i]), left, top, true);
				if (hit)  {
					break;
				}
			}
		}
	} 
	else {
		hit = false;
	}

	var garbage = getDivFromName("tabHome");
	var fusentail = getDivFromName("garbage");
	if (garbage != null) 
	{
		if (mouseOverDiv(garbage, left, top)) {
			grabObj.style.display='none';
			name = grabObj.id;
			num = parseInt(name.substring(3, name.length), 10);
			if (num != NaN) {
				activeTabs[num] = 0;
				tabsActiveCount--;

				writeDelTagInfoToCookie(grabObj.id);
				tagDivArr[grabObj.id.substr(3,grabObj.id.length)] = "";

				oldTextHash[grabObj.id] = "";
				fusentail.all.tags("img")[0].src = BASERESOURCE + "../fusentail" + saveBGColor + ".gif";

				return;
			}
		}
	}

	if (!hit) {
		var tagName = document.getElementById("tagName" + grabObj.id);
		tagDivArr[grabObj.id.substr(3,grabObj.id.length)] = "float";
		writeDelTagInfoToCookie(grabObj.id);
		saveFusenInfomation();
	}
}


function hideInputText()
{
	var tagName = document.getElementById("tagName" + grabObj.id);
	var tagNameInput = document.getElementById("tagNameInput" + grabObj.id);
	var bgcButton = document.getElementById("bgcButton" + grabObj.id);
	var colorTable = document.getElementById("colorTable" + grabObj.id);
	tagName.innerHTML=tagNameInput.value;
	tagName.style.display='inline';
	tagName.style.visibility='visible';
	tagNameInput.style.visibility='hidden';
	tagNameInput.style.display='none';
	bgcButton.style.visibility='hidden';
	bgcButton.style.display='none';
	colorTable.style.visibility='hidden';
	colorTable.style.display='none';	
}

function showInputText()
{
	var tagName = document.getElementById("tagName" + grabObj.id);
	var tagNameInput = document.getElementById("tagNameInput" + grabObj.id);
	var bgcButton = document.getElementById("bgcButton" + grabObj.id);
	var colorTable = document.getElementById("colorTable" + grabObj.id);
	tagName.style.visibility='hidden';
	tagName.style.display='none';
	tagNameInput.style.visibility='visible';
	tagNameInput.style.display='inline';
	bgcButton.style.visibility='visible';
	bgcButton.style.display='inline';
}



var yMoviePos;
var tagHeight = 30;

function arrangeTags(div, addObj)
{
	var videoTags = new Array();

	for (i=0; i<maxTabs; i++) {
		if (tagDivArr[i] == div.id) {
			tag = document.getElementById("tag" + i);
			videoTags[videoTags.length] = tag;
		}

		if (tagTwinDivArr[i] == div.id) {
			tag = document.getElementById("tag" + i + "b");
			videoTags[videoTags.length] = tag;
		}
	}

	var totaltags;
	var divtop = findPosY(div);

	totaltags = videoTags.length;
	if (addObj) {
		totaltags++;
	}
	if (totaltags == 0) {
		return;
	}

	innerElement = div.childNodes(0);
	if (subEl == null) {
		subEl = div;
	}
	offSetHeight = div.offsetHeight;
	offSetWidth = 2;

	rate = offSetHeight / tagHeight;

	if ((rate >= totaltags) && (addObj)) {
		topheight = (totaltags-1) * tagHeight;
		addObj.style.pixelTop = 0  + topheight;
		addObj.setAttribute("colID", 0);
		addObj.setAttribute("rowID", totaltags);

		newID = (0 + 1000) * 10000 + (1000 + totaltags);
		addObj.setAttribute("positionID", newID);
		if (isTwin(addObj)) {
			collapseTag(addObj);
		}

		return true;
	}

	if(addObj){
		videoTags[videoTags.length] = addObj;
	}
	var rowTotal =  parseInt(rate);
	var colTotal = parseInt(videoTags.length/rowTotal);
	rowCount = 0;
	colCount = 0;

	for (var j=0; j<videoTags.length; j++) {
		temptag = videoTags[j];
		newTop = rowCount * tagHeight ;

		if (colCount == 0) {
			newLeft =  0 + offSetWidth;
		} else {
			leftTag = videoTags[j-rowTotal];
			newLeft = leftTag.style.pixelLeft + leftTag.offsetWidth + 2;
			if (newLeft == 2) {
				newLeft = colCount * 41 + offSetWidth;
			}
		}
		temptag.style.pixelTop = newTop;
		temptag.style.pixelLeft = newLeft;
		collapseTag(temptag);

		newID = (colCount + 1000) * 10000 + (1000 + rowCount);
		temptag.setAttribute("positionID", newID);

		rowCount++;
		if (rowCount >= rowTotal) {
			rowCount = 0;
			colCount++;
		}
	}
	return true;
}



function Quicksort(vec, loBound, hiBound)
{
	var pivot, loSwap, hiSwap, temp;

	if (hiBound - loBound == 1)
	{
		if (vec[loBound].positionID > vec[hiBound].positionID)
		{
			temp = vec[loBound];
			vec[loBound] = vec[hiBound];
			vec[hiBound] = temp;
		}
		return;
	}

	pivot = vec[parseInt((loBound + hiBound) / 2)];
	vec[parseInt((loBound + hiBound) / 2)] = vec[loBound];
	vec[loBound] = pivot;
	loSwap = loBound + 1;
	hiSwap = hiBound;

	do {
		while (loSwap <= hiSwap && vec[loSwap].positionID <= pivot.positionID)
			loSwap++;

		while (vec[hiSwap].positionID > pivot.positionID)
			hiSwap--;

		if (loSwap < hiSwap)
		{
			temp = vec[loSwap];
			vec[loSwap] = vec[hiSwap];
			vec[hiSwap] = temp;
		}
	} while (loSwap < hiSwap);

	vec[loBound] = vec[hiSwap];
	vec[hiSwap] = pivot;

	if (loBound < hiSwap - 1)
		Quicksort(vec, loBound, hiSwap - 1);

	if (hiSwap + 1 < hiBound)
		Quicksort(vec, hiSwap + 1, hiBound);

}



function checkTagOverlap(yPos, div)
{
	left = findPosX(div) + div.offsetWidth;
	for (i=0; i< maxTabs; i++) {
		dragTag = document.getElementById("tag" + i);
		if (dragTag != null && dragTag.id != grabObj.id) {
			theTop=dragTag.style.pixelTop;
			if (yPos == theTop && dragTag.style.pixelLeft == left) {
				yMoviePos= yMoviePos+ 30;
				checkTagOverlap(yMoviePos, div);
			}
		}
	}
}

function checkTagExistsOnScene(div)
{
	for (i=0; i< maxTabs; i++) {
		if (tagDivArr[i] == div.id) {
			return true;
		}
	}
	return false;
}


function tagExpand(el){
	if (checkTagIsDocked(el)) {
		el.style.zIndex = 50;
		expose(el);
	}
}


function expose(el)
{
	var inputbox = document.getElementById("inputBox" + el.id);
	if (inputbox) {
		return;
	}
	var tagname = getTagName(el);
	if (tagname == null) {
		return;
	}

	if (oldTextHash[el.id]){
		tagname.innerHTML = oldTextHash[el.id];
	}
	el.style.overflow = "visible";
}


function collapseTag(el)
{
	el.style.overflow = "hidden";
	if (el.scrollWidth <= el.offsetWidth) {
		return;
	}
	var tagname = getTagName(el);
	if (tagname == null) {
		return;
	}

	var oldText = "";
	if (oldTextHash[el.id] != "" && oldTextHash[el.id] != null && typeof(oldTextHash[el.id]) != "undefined" ) {
		oldText = oldTextHash[el.id];
	} else {
		oldText = tagname.innerHTML;
	}
	var newText = "";
	for (var i=0; i<oldText.length; i++){
		newText = newText + oldText.charAt(i);
		tagname.innerHTML = newText + "..";

		if (el.scrollWidth > el.offsetWidth) {
			tagname.innerHTML = newText.substring(0, newText.length-1) + "..";
			break;
		}
	}

	el.style.zIndex = 4;
}


function getTagName(tagobj) {
	var tagNameObj;
	if (isTwin(tagobj)) {
		tagNameObj = document.getElementById("tagName" + tagobj.id);
	} else {
		tagNameObj = document.getElementById("tagName" + tagobj.id);
	}

	return tagNameObj;
}


function tagShrink(el){
	e = window.event;
	var prevBox = document.getElementById("inputBox" + el.id);

	if (checkTagIsDocked(el) && (!prevBox)) {
		el.style.zIndex = 4;
		collapseTag(el);
	}
}


function checkTagExistsOnVideo(tagObj){
	attachedDivId = tagDivArr[tagObj.id.substr(3,tagObj.id.length)];	
	if(isVideoRegion(attachedDivId) != -1){
		return true;
	}
	return false;
}

function checkTagIsDocked(tagObj){
	attachedDivId = getTagDivId(tagObj);
	if(attachedDivId){
		if((attachedDivId.length >0) && (attachedDivId != "float")){
			return true;
		}
	}
	return false;
}



var InitSettingFlag = 0;

function setToRegion(regionid, tabid) 
{
	var region = getDivFromName(regionid);
	tab = getDivFromName(tabid);
	grabObj = tab;
	leftRegion = findPosX(region);
	topRegion = findPosY(region);

	InitSettingFlag = 1;
	checkTagRegionDrop(region, leftRegion, topRegion, false);
	InitSettingFlag = 0;
}


function checkTagRegionDrop(div, left, top, saveFlag)
{
	var overTagRegion;
	overTagRegion = mouseOverDiv(div, left, top);

	if (checkTagExistsOnScene(div) && isVideoRegion(div.id) == -1) {
		grabObj.all.tags("img")[0].src = imgClose[0];
		currentTagRegion = null;
		return false;
	}

	if (overTagRegion && div.style.visibility != 'hidden') 
	{
		var tagName = document.getElementById("tagName" + grabObj.id);
		grabObj.all.tags("img")[0].src = imgtag;
		
		subEl = div.childNodes(0);
		if (subEl == null) {
			subEl = div;
		}
		grabObj.style.top = "0px";
		grabObj.style.left = "100%";

		var fusenDiv = getDivFromName(div.id + '_fusen');
		if (fusenDiv != null) {
			getDivFromName(div.id + '_fusen').appendChild(grabObj);
		} else {
			div.appendChild(grabObj);
		}

		updateTwin(grabObj);

		collapseTag(grabObj);

		yMoviePos = findPosY(div);
		
		var myNumber = grabObj.id.substr(3, grabObj.id.length);


		var regNumber = isVideoRegion(div.id);
		if (regNumber != -1) {
			grabObj.all.tags("img")[0].src = videotag;
			if (saveFlag) {
				tagTimeArr[myNumber] = getSegmentTime(videoRegion[regNumber]);
				arrangeTags(div, grabObj);
			}
		} 
		else{
			if (isMovingRegion(div.id) != -1){
				var oldGrab = grabObj;
				var twin = getFusenTwin(grabObj);
				var vid = getVideoRegion(left, top);

				if (InitSettingFlag == 1) {
					for (var i=0; i<videoRegion.length; i++) {
						var regionid = div.id;
						if (regionid.indexOf(videoRegion[i],0) != -1) {
							vid = getDivFromName(videoRegion[i]);
						}
					}
				}

				if (saveFlag) {
					tagTimeArr[myNumber] = getSegmentTime(vid.id);
					arrangeTags(div, grabObj); 
				}

				twin.style.display = "block";
				twin.style.top = "0px";
				twin.style.left = "100%";

				fusenDiv = getDivFromName(vid.id + '_fusen');
				if (fusenDiv != null) {
					getDivFromName(vid.id + '_fusen').appendChild(twin); // <- change 0916
				} else {
					vid.appendChild(twin);
				}

				twin.all.tags("img")[0].src = objtag;
				arrangeTags(vid, twin);

				tagTwinDivArr[getTagInt(twin)] = vid.id;
				collapseTag(grabObj);
			}
			else {
				grabObj.all.tags("img")[0].src = objtag;
			}
		}
		tagDivArr[myNumber] = div.id;

		currentTagRegion = div;

		if (saveFlag) {
			var tagtxt = oldTextHash[grabObj.id];
			var showText = changeEscapeChar(tagtxt);

			writeAddTagInfoToCookie(grabObj.id, showText, grabObj.style.backgroundColor, (regNumber != -1));
			saveFusenInfomation();
		}

		return true;
	}
	else{
		grabObj.all.tags("img")[0].src = imgClose[0];
		currentTagRegion = null;
	}

	return false;
}





function getFusenTwin(tagObj)
{
	var twinID = tagObj.id;
	if (!isTwin(tagObj)) {
		twinID = twinID + "b";
	}
	return document.getElementById(twinID);
}

function isTwin(tagObj){
	var lastChar = tagObj.id.charAt(tagObj.id.length-1);
	if (lastChar == 'b'){
		return true;
	}else{
		return false;
	}
}


function hasTwin(tagObj)
{
	var number = tagObj.id.substr(3, grabObj.id.length);
	return (isMovingRegion(tagDivArr[number]) != -1);
}


function getVideoRegion(left, top){
	var i;
	for (i=0; i<videoRegionCount; i++) {
		var vidReg = document.getElementById(videoRegion[i]);
		if (vidReg) {
			var overTagRegion = mouseOverDiv(vidReg, left, top);
			if (overTagRegion) {
				return vidReg;
			}
		}
	}
	return null;
}



function writeAddTagInfoToCookie(tagId, text, color, isVideo)
{
	var updateID = "FusenUpdate_" + MANUAL_NAME + "_" + tagId;

	setCookie("FusenLock", "Lock");
	setCookie(updateID, "Add");
	setCookie("FusenUpdatePageID", pageId);
	setCookie("FusenUpdateTagID", tagId);
	setCookie("FusenUpdateText", text);
	setCookie("FusenUpdateColor", color);
	setCookie("FusenUpdateIsVideo", isVideo);
	setCookie("FusenUpdatePageTitle", pageTitle);
	setCookie("FusenLock", "");
}


function writeDelTagInfoToCookie(tagId)
{
	var updateID = "FusenUpdate_" + MANUAL_NAME + "_" + tagId;

	setCookie("FusenLock", "Lock");
	setCookie(updateID, "Del");
	setCookie("FusenUpdatePageID", pageId);
	setCookie("FusenUpdateTagID", tagId);

	var bMoreTags = false;
	bMoreTags = (tabsActiveCount > 0) ? true : false;
	if (bMoreTags) {
		setCookie(updateID, "Del");
		setCookie("FusenUpdatePageID", pageId);
		setCookie("FusenUpdateTagID", tagId);
	} else {
		setCookie(updateID, "Del");
		setCookie("FusenUpdatePageID", pageId);
		setCookie("FusenUpdateTagID", "TagInfo");
	}
	setCookie("FusenLock","");
}



function isVideoRegion(id)
{
	var i;
	for (i=0; i<videoRegionCount; i++) {
		if (id == videoRegion[i]) {
			break;
		}
	}
	if (i == videoRegionCount || videoRegionCount == 0) {
		i = -1;
	}
	return i;
}


function isMovingRegion(id)
{
	var i;
	for (i=0; i<movingRegion.length; i++) {
		if (id == movingRegion[i]) {
			break;
		}
	}
	if (i == movingRegion.length || movingRegion.length == 0) {
		i = -1;
	}
	return i;
}


function tagAction(tag)
{
	grabObj = tag;
	checkID = setTimeout("mouseClick(clickedDiv)", 1000);
}

	
function appealTag(tag)
{
	if (checkID != "") {
		tagSelect();
	}
	clickedDiv = tag;
	checkID = setTimeout("tagSelect(clickedDiv)",1000);
}

function tagSelect()
{
	clearTimeout(checkID);
	checkID = "";
}


function resetTagDrag(e)
{
	tagdrag.all.tags("img")[0].src = imgClose[0];
	moveDivTo(tagdrag, tagXpos,tagYpos);
	setDivVisibility(tagdrag, true);
}


var tagbed = false;
var tag;
var tagstartX, tagstartY;

function toggleBGColor(colorTable)
{
	if(colorTable.style.visibility=="hidden"){
		colorTable.style.visibility="visible";
		colorTable.style.display="block";
	}else{
		colorTable.style.visibility="hidden";
		colorTable.style.display="none";
	}
}



function setBGColor(color, tag)
{
	if(color){
		if (color == '#dddddd') {
			color = '#fa4f24';
		}
		tag.style.backgroundColor = color;
		saveBGColor = color;

		if (tabsActiveCount != maxTabs) {
			garbage.all.tags("img")[0].src = BASERESOURCE + "../fusentail" + color + ".gif";
		}
	}
	return true;
}





function fusen(id, path)
{
	var a = '<div nowrap class="dragDiv" style="position:absolute;width:80px;display:none;overflow:visible;z-index:4;border-bottom:#555555 2px solid;border-right:#555555 2px solid;" onMouseEnter="tagExpand(this)" onMouseLeave="tagShrink(this)" onMouseDown="mouseDown(this);" id="' + id + '">' +
	 '<table><tr>' +
		'<td><img id="img' + id + '" src="' + path + 'usual.gif" style="cursor:hand;"></img></td>' +
		'<td style="width:100%;"><div nowrap class="tagName" id="tagName' + id + '" style="cursor:text;width:100%;font:bold normal 10pt lr SVbN;color:black;" ></div></td>' +
	 '</tr></table>' + 
	'</div>';

	var b = '<div nowrap class="dragDiv" style="position:absolute;width:80px;display:none;overflow:visible;z-index:4;border-bottom:#555555 2px solid;border-right:#555555 2px solid;" onMouseEnter="tagExpand(this)" onMouseLeave="tagShrink(this)" onMouseDown="mouseDown(this);" id="' + id + 'b">' +
	 '<table><tr>' +
		'<td><img id="img' + id + 'b" src="' + path + 'usual.gif" style="cursor:hand;"></img></td>' +
		'<td style="width:100%;"><div nowrap class="tagName" id="tagName' + id + 'b" style="cursor:text;width:100%;font:normal normal 10pt lr SVbN;;color:black;" ></div></td>' +
	 '</tr></table>' + 
	'</div>';

	var c = a + b;
	document.open();
	document.write(c);
	document.close();
}




function fusenHome(path)
{
	var a = '<div class="notdragDiv" id="tabHome" style="position:absolute;border:0;width:230;height:88;">' +
'<img src="' + path + 'fusen.gif" style="position:absolute;border:0" usemap="#mapfusen" >' +
'<div id="tabHomeTitleBar" onMouseDown="mouseDown(this);" style="filter:Alpha(opacity=0);position:absolute;top:1;left:1;width:200;height:15;font-size:0;background-color:blue"></div>' +
'<div id="homeArea" style="position:absolute;top:35;left:21;width:175;height:25;background-color:#FA4F24;">' + 
'<input id="tagNameInput" style="font-size:8pt;position:relative;top:5;left:7;height:15;width:161;" type="text">' + 
'</div>' +
'<div style="position:absolute;top:25;left:204;cursor:hand;width:27;" class="trash" id="garbage" onMouseDown="mouseDown(this);"><img src="' + path + 'fusentail#fa4f24.gif"></div>' +
'</div>' +
'<MAP name="mapfusen">' +
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#644FC4;" shape="rect" coords="5,19,16,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#3A5ACF;" shape="rect" coords="20,19,31,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#2F84DA;" shape="rect" coords="35,19,46,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#04A4EF;" shape="rect" coords="50,19,61,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#1ACFAF;" shape="rect" coords="65,19,76,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#24E40F;" shape="rect" coords="80,19,91,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#9ADA04;" shape="rect" coords="95,19,106,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#CFFA44;" shape="rect" coords="110,19,121,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#FAE44F;" shape="rect" coords="125,19,136,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#FAAF44;" shape="rect" coords="140,19,151,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#FA842F;" shape="rect" coords="155,19,166,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#FA4F24;" shape="rect" coords="170,19,181,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#DA0444;" shape="rect" coords="185,19,196,30">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#AF4FCF;" shape="rect" coords="5,34,16,45">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#EF4FC4;" shape="rect" coords="5,49,16,60">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#DA8F8F;" shape="rect" coords="5,64,16,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#E4CF9A;" shape="rect" coords="20,64,31,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#EFEF9A;" shape="rect" coords="35,64,46,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#CFFA9A;" shape="rect" coords="50,64,61,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#A4E4AF;" shape="rect" coords="65,64,76,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#9ACFE4;" shape="rect" coords="80,64,91,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#9AA4DA;" shape="rect" coords="95,64,106,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#BAA4E4;" shape="rect" coords="110,64,121,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#E4A4C4;" shape="rect" coords="125,64,136,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#9A8464;" shape="rect" coords="140,64,151,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#6F9A64;" shape="rect" coords="154,64,166,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#6F84BA;" shape="rect" coords="170,64,181,75">' + 
'<AREA onClick="setBGColor(event.srcElement.style.backgroundColor, homeArea);" style="background-color:#846484;" shape="rect" coords="185,64,196,75">' + 
'</MAP>';
	document.open();
	document.write(a);
	document.close();
}



function saveFusenInfomation()
{
	var ans = "adica:save_fusen/";
	for (i = 0; i < maxTabs; i++) {
		var tag = getDivFromName("tag" + i);
		var tagName = document.getElementById("tagName" + tag.id);
 		var icon = 0;

		if (isVideoRegion(tagDivArr[i]) != -1) {
			icon = 1;
		}
		if (isMovingRegion(tagDivArr[i]) != -1) {
			icon = 2;
		}

		var saveText = oldTextHash[tag.id];
		if (typeof(saveText) == "undefined") {
			if (typeof(tagName.innerHTML) != "undefined") {
				saveText = tagName.innerHTML;
			}
			else {
				saveText = "";
			}
		}

		ans += "?" + tagDivArr[i] + "?" + tag.style.backgroundColor + "?" + tag.style.pixelTop + "?"
			+ tag.style.pixelLeft + "?" + saveText + "?" + tagTimeArr[i] + "?" + icon;
	}

	ans += "?";

	linkTo(ans);
}



function swicthTabHome() {
	var home = getDivFromName("tabHome");
	if (home != null) {
		if (home.style.visibility == "visible") {
			home.style.visibility = "hidden";
		} else {
			home.style.visibility = "visible";
		}
	}
}

function showTabHome(mode)
{
	var home = getDivFromName("tabHome");
	if (home != null) {
		if (mode == "on") {
			home.style.visibility = "visible";
		} else if (mode == "off") {
			home.style.visibility = "hidden";
		}
	}
}


function checkMouseUp()
{
	var clickX = document.body.scrollLeft + window.event.clientX;
	var clickY = document.body.scrollTop + window.event.clientY;

	if (bSerachMode || bPrintMode) {
		if (bSerachMode && textSearchCheck()) {
			return;
		}
		for (var i=0; i<tagRegionNum; i++) {
			if (mouseOverDiv(eval(tagRegionArr[i]), clickX, clickY)) {
				var divID = tagRegionArr[i];
				var div = document.getElementById(divID);
				if (div) {
					if (div.style.visibility == 'hidden') {
						continue;
					}

					if (typeof(div) == "string"){
						linkTo('adica:direct_search/' + div);
					} else {
						linkTo('adica:direct_search/' + div.id);
					}
				}
				break;
			}
		}
	}
}


function setManualName(filename)
{
	MANUAL_NAME = filename;
}


