
var defaultWIDTH = 352;
var defaultHEIGHT = 240;

var INITIALIZED = false;
var UNLOADING = false;
var BASERESOURCE = "";

var FPS = 29.970;

var firstRow = ['oSlider']; 
var secondRow = ['playButton','stopButton','prevButton', 'nextButton', 'repeatButton', 'slowButton', 'fastButton', 'soundButton','vSlider'];
var r2Count = 0;
var videolist = new Object();
var uiHashtable = new Object();
var requestedWidth = new Object();
var requestedHeight = new Object();
var initProgressList = new Array();
var currentTimePosition = new Array();


var playImgOn = new Image();
var playImgOff = new Image();
var playImgOver = new Image();
var pauseImgOn = new Image();
var pauseImgOff = new Image();
var pauseImgOver = new Image();
var stopImgOn = new Image();
var stopImgOff = new Image();
var stopImgOver = new Image();
var prevImgOn = new Image();
var prevImgOff = new Image();
var prevImgOver = new Image();
var nextImgOn = new Image();
var nextImgOff = new Image();
var nextImgOver = new Image();
var repeatImgOn = new Image();
var repeatImgOff = new Image();
var repeatImgOver = new Image();
var speedFastOn = new Image();
var speedFastOff = new Image();
var speedFastOver = new Image();
var speedSlowOn = new Image();
var speedSlowOff = new Image();
var speedSlowOver = new Image();
var soundImgOn = new Image();
var soundImgOff = new Image();
var soundImgOver = new Image();

var stepBackImgOn = new Image();
var stepBackImgOff = new Image();
var stepBackImgOver = new Image();
var stepForwardImgOn = new Image();
var stepForwardImgOff = new Image();
var stepForwardImgOver = new Image();

var showFullImgOn = new Image();
var showFullImgOff = new Image();
var showFullImgOver = new Image();

var PROGRESS_END_CORRECT = 0.050;
var SEEK_AFTER_CORRECT = 0.030;


function playNextEntryNumber(videoID, number)
{
		var vid = getVideo(videoID);
		var t = vid.animation.currTimeState.segmentTime;

		var startingFrame;
		var bnewMovie = false;

		if (number > 0) {
			if (vid.currentEntry.timelineid != null) {
				oldtimeline = document.getElementById(vid.currentEntry.timelineid);
				oldtimeline.endElement();
			}

			var layer = document.getElementById(vid.currentEntry.divid);
			layer.style.visibility = "hidden";

			bnewMovie = true;
		}

		vid.currentEntry = vid.playlist[number];

		var timeleine = null;
		if (vid.currentEntry.timelineid != null) {
			timeline = document.getElementById(vid.currentEntry.timelineid);
		}

		movie = document.getElementById(vid.currentEntry.movieid);
		layer = document.getElementById(vid.currentEntry.divid);
		layer.style.visibility = "visible";

		if (!movie.currTimeState.isActive && timeline != null) {
			PRELOADID = vid.currentEntry.movieid;

			timeline.beginElement();
			PRELOADID = null;
		}
		vid.updateSpeed();

		updateIndex(vid, "" + number);
		updateScene(videoID, vid.currentEntry.hybridStartTime);


		currentTimePosition[vid.videoID] = vid.currentEntry.hybridStartTime + 0.01;

		if (vid.currentEntry.useFrames) {
			if (movie.currTimeState.isActive) {
				movie.seekToFrame(vid.currentEntry.beginframe);
			}
		} else {
			if (movie.currTimeState.isActive) {
				movie.seekSegmentTime(vid.currentEntry.begintime);
			}
		}

		if (vid.bMovieMute) {
			movie.volume = 0;
		} else {
			movie.volume = vid.CURRENTVOL;
		}

		if (!vid.moviePaused && timeline != null) {
			timeline.resumeElement();
		}
		vid.movieStarted = true;

		preloadNextMovie(videoID, number, true);
}



function getVidID(obj)
{
	var length = obj.id.length;
	var endPos = length -1;
	var c; 
	for(var i=endPos; i >= 0; i--){
		c = obj.id.charAt(i);
		if(c == '_'){
			return obj.id.substring(0,i);
		}
	}
	return null;
}

function getVidHalf(obj){
	var length = obj;
	var endPos = length -1;
	var c; 
	for(var i=endPos; i >= 0; i--){
		c = obj.charAt(i);
		if(c == '_'){
			return obj.substring(i,length);
		}
	}
	return null;
}


function getVideo(obj){
	var vidid;
	if(typeof(obj)=="string"){
		vidid = obj;
	}else{
		vidid = getVidID(obj);
	}
	return videolist[vidid];
}


function videoEntry(videoID)
{
	this.videoID = videoID;
	this.MAXFRAME = 0;
	this.TOTALTIME = 0;
	this.TOTALENTRIES = 0;

	this.CURRENTSPEED = 1;
	this.CURRENTVOL = 100;
	this.PRELOADID = null;
	this.NEXTDISABLE = false;
	this.playlist = new Array();
	this.scenelist = new Array(); 

	this.currentEntry = null;
	this.currentScene = null;

	this.movieStarted = false;
	this.moviePaused = false;
	this.movieFinished = false;
	this.movieStoped = false;
	this.timePosition = 0;

	this.buffering = false;
	this.bsliderDown = false;
	this.bsliderDownV = false;
	this.bSeekInProgress = false;
	this.bRepeat = false;
	this.bMovieMute = false;
	this.bAutoStart = false;
	this.bSVGTimerSet = false;
	this.autoStartTime = 200;
	this.bInitLoadComp = false;

	this.bMovieIsActive = false;
	this.bSeekEvent = false;
	this.stopCommand = -1;

	this.svgTimerID = null;
	this.delayedSeekID = null;
	this.seekSTimerID = null;
	this.seekS2TimerID = null;
	this.playTimerID = null;
	this.stopBtnTimerID = null;
	this.uisetupTimerID = null;
	this.speedTimerID = null;
	this.audioTimerID = null;

	this.eventExecFlag = false;
	this.timerFlag = 0;

	this.animation = document.getElementById(videoID + "_animationMain");
	this.animationTimeline = document.getElementById(videoID + "_animationMainTime");
	this.slider = document.getElementById(videoID + "_oSlider");
	this.vSlider = document.getElementById(videoID + "_vSlider");
	this.indexframe = document.getElementById(videoID + "_indexframe");
	this.scenetime = document.getElementById(videoID + "_scene");
	this.slowButton = document.getElementById(videoID + "_slowButton");
	this.fastButton = document.getElementById(videoID + "_fastButton");

	function addPlaylistEntry(playentry){
		this.playlist[this.playlist.length] = playentry;
	}

	function addScenelistEntry(sceneEntry){
		this.scenelist[this.scenelist.length] = sceneEntry;
	}

	this.speedDefault = 2;
	this.currentSpeedIndex = 2;
	this.speedArray = [0.55, 0.75, 1.0, 1.5, 2.0];

	function speedChange(num)
	{
		var newSpeedIndex = this.currentSpeedIndex + num;
		if (newSpeedIndex < 0) {
			newSpeedIndex = 0;
		} else if (newSpeedIndex >= this.speedArray.length) {
			newSpeedIndex = this.speedArray.length - 1;
		}

		if ((newSpeedIndex != this.speedDefault) && (!this.bSVGTimerSet)) {
			if (svgSupport[this.videoID]) {
				var callstr = "syncSVGTime('" + this.videoID + "')";
				this.svgTimerID = setInterval(callstr, 100);
				this.bSVGTimerSet = true;
			}
		}

		if ((this.bSVGTimerSet) && (newSpeedIndex == this.speedDefault)) {
			if (svgSupport[this.videoID]) {
				this.bSVGTimerSet = false;
				clearInterval(this.svgTimerID);
			}
		}

		this.currentSpeedIndex = newSpeedIndex;
		this.CURRENTSPEED = Math.round(this.speedArray[newSpeedIndex] * 1000) / 1000;
		this.updateSpeed();
	}

	function updateSpeed()
	{
		if (!this.currentEntry) {
			return;
		}

		var timeline = null;
		if (this.currentEntry.timelineid != null) {
			timeline = document.getElementById(this.currentEntry.timelineid);
		}

		if (timeline != null) {
			if ((timeline.speed != this.CURRENTSPEED) || (this.animationTimeline.speed != this.CURRENTSPEED)) {
				if (!this.currentEntry.isWMV) {
					timeline.speed = this.CURRENTSPEED;
					this.animationTimeline.speed = this.CURRENTSPEED;
				} 
				else {
					timeline.speed = 1.0;
					this.animationTimeline.speed = 1.0;
				}
			}
			
			this.slowButton.title = 'Đx:' + Math.round(timeline.speed * 1000) / 1000 + '{';
			this.fastButton.title = 'Đx:' + Math.round(timeline.speed * 1000) / 1000 + '{';
		}
	}

	this.addPlaylistEntry = addPlaylistEntry;
	this.addScenelistEntry = addScenelistEntry;
	this.updateSpeed = updateSpeed;
	this.speedChange = speedChange;
}



function sceneEntry(videoID, index, begin, end)
{
	this.videoID = videoID;
	this.index = index;
	this.begin = begin;
	this.end = end;
	this.videoEntryIndex = -1;
	this.videoSeekTo = -1;
}

function playEntry(videoID, index, srcloc) 
{
	this.videoID = videoID;
	this.index = index;
	this.srcLocation = srcloc;
	this.preloaded = false;
	this.useFrames = false;
	this.totalframes = 0;
	this.totaltime = 0;
	this.hybridStartTime = 0;
	this.hybridEndTime = 0;
	this.isWMV = false;

	this.timelineid = null;
	this.movieid = null;
	this.divid = null;

	this.begintime = 0;
	this.endtime = 0;
	this.endTimeString = "";

	if (this.srcLocation.indexOf(".wmv") != -1 ) {
		this.isWMV = true;
	}

	function setFrameRange(begin, end) {
		this.beginframe = begin;
		this.endframe = end;
		begintime = parseFloat((1 / FPS)) * begin;
		dur = parseFloat((1 / FPS)) * end;
		this.begintime = Math.round(begintime * 1000) / 1000; 
		this.endtime = Math.round(dur * 1000) / 1000;
		this.endTimeString = this.endtime + "s";
		this.totalframes = end - begin;
		dur = parseFloat((1 / FPS)) * this.totalframes;
		this.totaltime = Math.round(dur * 1000) / 1000;
		this.useFrames = true;
	}

	function setRange(begin, end) {
		this.begintime = parseFloat(begin);
		this.endtime = parseFloat(end);
		this.totaltime = this.endtime - this.begintime;
		this.endTimeString = this.endtime + "s";
	}

	this.setRange = setRange;
	this.setFrameRange = setFrameRange;
}


function searchScene(obj, seekNum)
{
	var searchVid = getVideo(obj);
	var currTime = searchVid.animation.currTimeState.segmentTime;
	var tempScene = null;
	var maxScene = null;

	if ((seekNum == -1)||(seekNum == 0)){
		for (var i=0; i < searchVid.scenelist.length; i++){
			tempScene = searchVid.scenelist[i];
			if ((!maxScene) && (tempScene.begin < currTime)){
				maxScene = tempScene;
			}
			else if ((maxScene) && (tempScene.begin < currTime) && (tempScene.begin > maxScene.begin)){
				maxScene = tempScene;
			}
		}
	}

	if ((seekNum == 1)) {
		for (var i=0; i<searchVid.scenelist.length; i++){
			tempScene = searchVid.scenelist[i];
			if ((!maxScene) && (tempScene.begin > currTime)){
				maxScene = tempScene;
			}
			else if ((maxScene) && (tempScene.begin > currTime) && (tempScene.begin < maxScene.begin)){
				maxScene = tempScene;
			}
		}
	}
	if (maxScene == null) {
	  return 0;
	}
	
	return maxScene.index;
}

function nextScene(obj, seekNum, beforePaused)
{
	var vid = getVideo(obj);

	if (vid.scenelist.length == 0) {
		return true;
	}

	var number = 0;
	if ((!vid.currentEntry) && (!vid.currentScene)) {
		number = 1;
	}
	else {
		if (!vid.currentScene) {
			number = searchScene(obj, seekNum);
		} else {
			number = vid.currentScene.index + seekNum;
		}
	}

	if (number >= vid.scenelist.length) {
		return;
	}
	else if (number < 0) {
		number = 0;
	}
	
	var nextscene = vid.scenelist[number]
	var nextEntry = vid.playlist[nextscene.videoEntryIndex];

	var timeto = nextscene.begin;
	var seekto = nextscene.videoSeekTo;
	vid.NEXTDISABLE = true;
	vid.NEXTDISABLE = false;

	currentTimePosition[vid.videoID] = timeto;	
	
	var p = timeto / vid.TOTALTIME;
	var slideVal = parseInt(p * 100);
	if (slideVal == 99) {
		slideVal = 100;
	}
	vid.timePosition = slideVal;

	seekToEntryNumber(obj, nextscene.videoEntryIndex, seekto, timeto);

	if (beforePaused == true) 
	{
		var moreSeek = timeto + SEEK_AFTER_CORRECT;
		if (vid.delayedSeekID != null) {
			setTimeout("delayedSeekToAnimate('" + vid.videoID + "'," + moreSeek + ")", 200);
		} else {
			if (vid.animation != null && vid.animation.currTimeState.isActive) {
				vid.animation.seekActiveTime(moreSeek);
			}
			svgSeek(vid.videoID, moreSeek);
		}
	}
}



function seekToTimeS(seekVidID, seektime) 
{
	var vid = getVideo(seekVidID);

	if (vid.seekSTimerID != null) {
		clearTimeout(vid.seekSTimerID);
		vid.seekSTimerID = null;
	}
	if (!vid.bInitLoadComp && videoLevel == 0) {
		vid.seekSTimerID = setTimeout("seekToTimeS('" + seekVidID + "'," + seektime + ")", 100);
		return true;
	}
	
	vid.bMovieIsActive = true;

	if (vid.stopCommand < 1)
	{
		if (vid.playTimerID != null) {
			clearTimeout(vid.playTimerID);
			vid.playTimerID = null;
		}
		vid.playTimerID = setTimeout("playMovie('" + seekVidID + "')", 0);

		if (vid.seekS2TimerID != null) {
			clearTimeout(vid.seekS2TimerID);
			vid.seekS2TimerID = null;
		}
		vid.seekS2TimerID = setTimeout("seekToTimeS2('" + seekVidID + "'," + seektime + ")", 10);
	}
	else if (vid.stopCommand == 1) {
		playMovie(seekVidID);
		pauseUp(seekVidID);
		vid.stopCommand = 0;
	}
	else if (vid.stopCommand == 2) {
		playMovie(seekVidID);
		stopElements(seekVidID);
		vid.stopCommand = 0;
	}
	else if (vid.stopCommand == 3) {
		if (vid.playTimerID != null) {
			clearTimeout(vid.playTimerID);
			vid.playTimerID = null;
		}
		vid.playTimerID = setTimeout("playMovie('" + seekVidID + "')", 0);
		vid.stopCommand = 0;
	}
}



function seekToTimeS2(seekVidID, seektime) 
{
	var vid = getVideo(seekVidID);

	if (vid.seekS2TimerID != null) {
		clearTimeout(vid.seekS2TimerID);
		vid.seekS2TimerID = null;
	}

	if (vid.stopCommand == 1) {
		playMovie(seekVidID);
		pauseUp(seekVidID);
		vid.stopCommand = 0;
	}
	else if (vid.stopCommand == 2) {
		playMovie(seekVidID);
		stopElements(seekVidID);
		vid.stopCommand = 0;
	}

	if (vid.currentEntry != null && vid.currentEntry.timelineid != null) {
		currentTimeline = document.getElementById(vid.currentEntry.timelineid);
		currentTimeline.pauseElement();
	}
	vid.animationTimeline.pauseElement();
	svgPause(vid.videoID);
	var beforePaused = vid.moviePaused;
	vid.moviePaused = true;

	seekToTime(seekVidID, seektime);

	if (!beforePaused) {
		if (vid.playTimerID != null) {
			clearTimeout(vid.playTimerID);
			vid.playTimerID = null;
		}

		vid.playTimerID = setTimeout("playEventAfter('" + seekVidID + "')", 300);
	}
}



function seekToTime(seekVidID, seektime)
{
	var seekToVid = getVideo(seekVidID);
	updateDisplay(seekToVid);
	execSeekProcess(seekVidID, seektime);
}




function seekTimeline(seekVidID, percent)
{
	var seekToVid = getVideo(seekVidID);

	var seekPosition = seekToVid.TOTALTIME * percent;
	seekPosition = Math.round(seekPosition * 1000) / 1000;

	execSeekProcess(seekVidID, seekPosition);
}


function execSeekProcess(seekVidID, seekTime)
{
	var seekToVid = getVideo(seekVidID);
	var entry = null;
	var entryNumber = null;

	var percent = seekTime / seekToVid.TOTALTIME;
	var seekPosition = Math.round(seekTime * 1000) / 1000;
	var tempTime = seekPosition;

	var bFound = false;
	for (var i=0; i<seekToVid.TOTALENTRIES; i++)
	{
		entry = seekToVid.playlist[i];
		var entryTime = Math.round(entry.totaltime * 1000) / 1000;
		entryNumber = i;

		if ((tempTime - entryTime) < 0){
			bFound = true;
			break;
		}
		else if (seekToVid.TOTALENTRIES == 1 && i == 0 && (tempTime - entryTime) == 0) {
			bFound = true;
			break;
		}
		else {
			tempTime = tempTime - entryTime;
			tempTime = Math.round(tempTime * 1000) / 1000;
		}
	}

	entry = seekToVid.playlist[entryNumber];
	if (!entry) {
		return; 
	}
	var seekto = tempTime + entry.begintime;
	seekto = Math.round(seekto * 1000) / 1000;

	var timeto = seekPosition;
	seekToEntryNumber(seekVidID, entryNumber, seekto, timeto);


	if (percent < 1) 
	{
		seekToVid.timePosition = percent;

		var nextTest = seekToVid.playlist[entryNumber + 1];
		if (!nextTest) {
			seekToEntryNumber(seekVidID, entryNumber, seekto, timeto);
		}
		else {
			var nextTest = null;
			if (seekToVid.playlist[entryNumber + 1].timelineid != null) {
				nextTest = document.getElementById(seekToVid.playlist[entryNumber + 1].timelineid);
			}

			if (nextTest) {
				//seekToEntryNumber(seekVidID, entryNumber, seekto, timeto);
			} else {
				//seekToEntryNumberNew(seekVidID, entryNumber, seekto, timeto);
			}
		}
	}
	else {
		pauseUp(seekVidID);
		seekToEntryNumber(seekVidID, entryNumber, seekto - PROGRESS_END_CORRECT, timeto);
		seekToVid.timePosition = 1;

		if (seekToVid.animation){
			seekToVid.animation.seekActiveTime(seekToVid.TOTALTIME - PROGRESS_END_CORRECT);
			seekToVid.animationTimeline.pauseElement();
			svgPause(seekToVid.videoID);
			svgSeek(seekToVid.videoID, seekToVid.TOTALTIME - PROGRESS_END_CORRECT);
		}

		imgSwap(seekToVid.videoID + "_playButton", playImgOff.src);
		var playButton = document.getElementById(seekToVid.videoID + "_playButton");
		playButton.title = 'Đ';
	}
}


function stepToTime(obj, plusTime)
{
	var vid = getVideo(obj);
	var t = vid.animation.currTimeState.segmentTime;

	var seekTime = t + plusTime;
	if (seekTime > vid.TOTALTIME) {
		seekTime = vid.TOTALTIME;
	} else if (seekTime < 0) {
		seekTime = 0;
	}

	seekToTimeS2(vid.videoID, seekTime);
}





function hideCurrentVid(vid)
{
	if (vid.currentEntry.timelineid != null) {
		timeline = document.getElementById(vid.currentEntry.timelineid);
		timeline.endElement();
		layer = document.getElementById(vid.currentEntry.divid);
		layer.style.visibility = "hidden";
	}

}


function reloadMovieDuration(timelineid, movieid, duration)
{
	timeline = document.getElementById(timelineid);
	timeline.endElement();
	movie = document.getElementById(movieid);
	movie.dur = duration;

	timeline.beginElement();
	timeline.beginElement();
}


function toggleNextEntry(nextEntry, vid) 
{
	var timeA = vid.videoID + "_timelineA";
	if (vid.currentEntry.timelineid != null) {
		var letter = (vid.currentEntry.timelineid == timeA) ? "B" : "A";
		nextEntry.timelineid = vid.videoID + "_timeline" + letter;
		nextEntry.divid = vid.videoID + "_div" + letter;
		nextEntry.movieid = vid.videoID + "_video" + letter;
	}

	return true;
}


function getNextVideo(vid) 
{
	videoid = vid.currentEntry.videoID;
	var vName = getVidHalf(videoid);
	nextvidid = (vName == "videoA") ? "videoB" : "videoA";
	nextvidid = vid.videoID + "_" + nextvidid;

	return document.getElementById(nextvidid);
}


function seekToEntry(vid, number, frame, timeto)
{
	vid.currentEntry = vid.playlist[number];
	var layer = document.getElementById(vid.currentEntry.divid);
	layer.style.visibility = "visible";

	var movie = document.getElementById(vid.currentEntry.movieid);
	movie.seekToFrame(frame);
	if(!vid.moviePaused){
		timeline.resumeElement();
	}
}

function seekToEntryNumber2(vid, number, frame, timeto)
{
	if (vid.currentEntry.timelineid != null) {
		var nextEntry = vid.playlist[number];
		reloadMovieDuration(vid.currentEntry.timelineid, vid.currentEntry.movieid, nextEntry.endTimeString)
		seekToEntry(vid, number, frame, timeto);
	}
}

function seekToEntryNumber3(vid, number, frame, timeto)
{
	hideCurrentVid(vid);
	var nextEntry = vid.playlist[number];
	var nextVid = getNextVideo(vid);

	if (nextVid.src == requestedSrc){ 
		toggleNextEntry(nextEntry, vid);
		reloadMovieDuration(nextEntry.timelineid, nextEntry.movieid, nextEntry.endTimeString);
		seekToEntry(vid, number, frame, timeto);
	}else{
		preloadNextMovie(obj, number-1, true);
		var tstring = "delayedSeek('" + vid.videoID + "'," + number + "," + frame + "," + timeto + ");"
	}
}


function seekToEntryNumberNew(obj, number, frame, timeto)
{
	var vid = getVideo(obj);
	var nextEntry = vid.playlist[number];

	var requestedSrc = nextEntry.srcLocation;
	var requestedScene = number;

	var currentSrc = vid.currentEntry.srcLocation;
	var currentScene = vid.currentEntry.index;

	if ((currentSrc == requestedSrc) && (requestedScene == currentScene)) {
		seekToEntry(vid, number, frame, timeto);
	} else if ((currentSrc == requestedSrc) && (requestedScene != currentScene)) {
		nextEntry.timelineid = vid.currentEntry.timelineid;
		nextEntry.movieid = vid.currentEntry.movieid;
		nextEntry.divid = vid.currentEntry.movieid;
		seekToEntryNumber2(vid, number, frame, timeto);
	} else {
		seekToEntryNumber3(vid, number, frame, timeto);
		return;
	}

	vid.animation.seekActiveTime(timeto);
	svgSeek(vid.videoID, timeto);
}



function seekToEntryNumber(obj, number, frame, timeto)
{
	var vid = getVideo(obj);
	var nextEntry = vid.playlist[number];

	var requestedSrc = nextEntry.srcLocation;
	var requestedScene = number;
	var startingFrame;
	var bseekFromInit = false;
	var bnewMovie = false;

	vid.NEXTDISABLE = true;

	if (!vid.movieStarted) {
		vid.currentEntry = vid.playlist[0];
		vid.moviePaused = true;
		bseekFromInit = true;
		vid.animationTimeline.beginElement();
		vid.animationTimeline.pauseElement();
	}

	var currentSrc = vid.currentEntry.srcLocation;
	var currentScene = vid.currentEntry.index;
	
	if (vid.currentEntry.index != number) {
		if (vid.currentEntry.timelineid != null) {
			element = document.getElementById(vid.currentEntry.timelineid);
			element.endElement();
		}
		var layer = document.getElementById(vid.currentEntry.divid);
		layer.style.visibility = "hidden";
		bnewMovie = true;
	}

	var next = vid.currentEntry.index + 1;

	if (((bnewMovie) && (number != next)) || (bseekFromInit)) {
		preloadNextMovie(obj, number-1, true);
	}

	vid.currentEntry = vid.playlist[number];
	var movie = document.getElementById(vid.currentEntry.movieid);
	var layer = document.getElementById(vid.currentEntry.divid);
	layer.style.visibility = "visible";

	var timeline = null;
	if (vid.currentEntry.timelineid != null) {
		timeline = document.getElementById(vid.currentEntry.timelineid);
	}
	if (!movie.currTimeState.isActive && timeline != null) {
		vid.PRELOADID = vid.currentEntry.movieid;
		timeline.beginElement();
		vid.PRELOADID = null;	
	}

	vid.updateSpeed();

	var tstring = "delayedSeek('" + vid.videoID + "'," + number + "," + frame + "," + timeto + ");"
	vid.PRELOADID = null;
	updateIndex(vid, "" + number);

	if ((number != next) && (bnewMovie)) {
		if (vid.delayedSeekID != null) {
			clearTimeout(vid.delayedSeekID);
			vid.delayedSeekID = null;
		}
		vid.delayedSeekID = setTimeout(tstring, 200);
	}
	else {
		if (vid.currentEntry.useFrames) {
			if (movie.currTimeState.isActive) {
				movie.seekToFrame(frame);
			}
		}
		else {
			if (movie.currTimeState.isActive) {
				movie.seekTo(1, frame);
			}
		}

		if (!vid.moviePaused){
			timeline.resumeElement();
		} else{
			timeline.pauseElement();
		}

		if (vid.bMovieMute) {
			movie.volume = 0;
		} else {
			movie.volume = vid.CURRENTVOL;
		}

		if (bnewMovie) {
			preloadNextMovie(vid.videoID, number, true);
		}

		if (vid.animation && vid.animation.currTimeState.isActive){
			vid.animation.seekActiveTime(timeto);
			svgSeek(vid.videoID, timeto);
		}

		updateScene(vid.videoID, timeto);
		vid.NEXTDISABLE = false;
		vid.bSeekInProgress = false;
	}

	vid.movieStarted = true;
}




function updateIndex(vid, htmlString)
{
	if (vid.indexframe) {
		vid.indexframe.innerHTML = htmlString;
	}
	return;
}



function delayedSeek(dvideoID, number, frame, timeto)
{
		var delayvid = getVideo(dvideoID);

		var timeline = null;
		if (delayvid.currentEntry.timelineid != null) {
			timeline = document.getElementById(delayvid.currentEntry.timelineid);
		} else {
			return;
		}
		var movie = document.getElementById(delayvid.currentEntry.movieid);

		if (delayvid.currentEntry.useFrames) {
			if (movie.currTimeState.isActive) {
				movie.seekToFrame(frame);
			}
		} else {
			if (movie.currTimeState.isActive) {
				movie.seekSegmentTime(frame);
			}
		}

		if (!delayvid.moviePaused) {
			timeline.resumeElement();
		} else {
			timeline.pauseElement();
		}
		
		if (delayvid.bMovieMute) {
			movie.volume = 0;
		} else {
			movie.volume = delayvid.CURRENTVOL;
		}
		
		preloadNextMovie(dvideoID, number, true);

		if (delayvid.animation.currTimeState.isActive){
			delayvid.animation.seekActiveTime(timeto);
		}
		svgSeek(delayvid.videoID, timeto);

		updateScene(dvideoID, timeto);
		delayvid.NEXTDISABLE = false;

		if (delayvid.delayedSeekID != null) {
			clearTimeout(delayvid.delayedSeekID);
			delayvid.delayedSeekID = null;
		}

		delayvid.bSeekInProgress = false;
}



function preloadNextMovie(videoID, currentIndex, forcePreload) 
{
	var nextIndex = currentIndex + 1;
	var bTimeA = true;
	var vid = getVideo(videoID);
	var nextEntry = vid.playlist[nextIndex];

	if (!forcePreload) {
		var nextvid = getNextVideo(vid);
		if(vid.currentEntry.srcLocation == nextEntry.srcLocation){
			nextEntry.timelineid = vid.currentEntry.timelineid;
			nextEntry.movieid = vid.currentEntry.movieid;
			nextEntry.divid = vid.currentEntry.divid;
			return true;
		}
		else if (nextvid.src == nextEntry.srcLocation) {
			toggleNextEntry(nextEntry, vid);
			return true;
		}
	}

	if (nextIndex >= vid.TOTALENTRIES) {
		return;
	}

	var timeA = vid.videoID + "_timelineA";
	var letter = (vid.currentEntry.timelineid == timeA) ? "B" : "A";
	nextEntry.timelineid = vid.videoID + "_timeline" + letter;
	nextEntry.divid = vid.videoID + "_div" + letter;
	nextEntry.movieid = vid.videoID + "_video" + letter;

	var movie = document.getElementById(nextEntry.movieid);
	var timeline = document.getElementById(nextEntry.timelineid);

	if (movie.src != nextEntry.srcLocation) {
		movie.src = nextEntry.srcLocation;
	} else {
	}
	var endTime = "" + nextEntry.endtime + "s";
	movie.dur = endTime;

	vid.PRELOADID = nextEntry.movieid;
	timeline.beginElement();
	timeline.beginElement();
	timeline.pauseElement();

	initProgressList[vid.currentEntry.timelineid] = 0;
	vid.PRELOADID = null;
}



function beginMovie(obj)
{
	var vid = getVideo(obj);

	svgStop(vid.videoID);

	playNextEntryNumber(obj, 0);
	vid.animationTimeline.beginElement();
	svgResume(vid.videoID);
	vid.movieStarted = true;
}


function next(obj) 
{
	if (UNLOADING) {
		return;
	}
	var vid = getVideo(obj); 
	var t = vid.animation.currTimeState.segmentTime;

 	if (vid.PRELOADID == obj.id) {
		return;
	}
	if (vid.delayedSeekID) {
		return;
	}
	if (vid.NEXTDISABLE) {
		return;
	}

	if ((vid.bRepeat) && (!vid.bSeekInProgress)) {
		sceneEnd(obj);
		return
	}

	if ((vid.currentEntry) && (vid.movieStarted != false) && (vid.moviePaused != true)) {
		index = vid.currentEntry.index + 1;
		index = vid.currentEntry.index + 1;
		
		if (index < vid.TOTALENTRIES) {
			playNextEntryNumber(obj, index);
		} 
		else {
			if (!vid.animationTimeline.currTimeState.isActive){
				//vid.animationTimeline.beginElement();
			}
			//vid.animationTimeline.beginElement();

			if (vid.animation)
			{
				var endtime = vid.TOTALTIME - PROGRESS_END_CORRECT;
				if (vid.animation.currTimeState.isActive) {
					vid.animation.seekActiveTime(endtime);
				}
				vid.animationTimeline.pauseElement();

				svgPause(vid.videoID);
				svgSeek(vid.videoID, endtime);
				vid.moviePaused = true;
			}

			timeline = document.getElementById(vid.currentEntry.timelineid);
			movie = document.getElementById(vid.currentEntry.movieid);

			if (!movie.currTimeState.isActive && timeline) {
				vid.NEXTDISABLE = true;
				timeline.beginElement();
			}
			if (!vid.animationTimeline.currTimeState.isActive) {
				vid.animationTimeline.beginElement();
			}

			if (movie && movie.currTimeState.isActive) {
				movie.seekSegmentTime(vid.currentEntry.endtime - PROGRESS_END_CORRECT);
			}
			timeline.pauseElement();

			vid.NEXTDISABLE = false;
			vid.timePosition = 100;
			vid.movieFinished = true;
			vid.moviePaused = true;


			imgSwap(vid.videoID + "_playButton", playImgOff.src);
			var playButton = document.getElementById(vid.videoID + "_playButton");
			playButton.title = 'Đ';
		}
	}
}


function calcTimes(videoID)
{
	var vid = videolist[videoID];

	var maxframes = 0;
	var timetotal = 0;
	var hybridStartTime = 0;
	vid.MAXFRAME = 0;
	vid.TOTALTIME = 0;

	for (var i=0; i<vid.playlist.length; i++) {
		var entry = vid.playlist[i];
		entry.hybridStartTime = hybridStartTime;

		var entryTotaltime = Math.round(entry.totaltime * 1000) / 1000;
		entry.hybridEndTime = entry.hybridStartTime + entryTotaltime;
		entry.hybridEndTime = Math.round(entry.hybridEndTime * 1000) / 1000;

		maxframes = maxframes + entry.totalframes;
		timetotal = timetotal + entry.totaltime;

		timetotal = Math.round(timetotal * 1000) / 1000;
		hybridStartTime = timetotal;
	}

	for (var j=0; j<vid.scenelist.length; j++)
	{
		var bsceneFound = false;
		var scene = vid.scenelist[j];
		var starttime = scene.begin;
		starttime = Math.round(starttime * 1000) / 1000;

		for (var k=0; k<vid.playlist.length; k++) 
		{
			var entry = vid.playlist[k];
			if ((starttime >= entry.hybridStartTime) && (starttime < entry.hybridEndTime)) {
				var diff = starttime - entry.hybridStartTime;
				scene.videoEntryIndex = k;
				scene.videoSeekTo = entry.begintime + diff;
				bsceneFound = true;
				break;
			}
		}
	}

	timetotal = Math.round(timetotal * 1000) / 1000;

	vid.MAXFRAME = maxframes;
	vid.TOTALTIME = timetotal;
	var aniTimeTotal = timetotal + 5;
	vid.animation.dur = aniTimeTotal + "s";
	vid.TOTALENTRIES = vid.playlist.length;
	
	if (vid.TOTALTIME < 10.00) {
		PROGRESS_END_CORRECT = 0.030;
	}
}



function tagElem(tagName){
	this.tagNamee=tagName;
	this.attrCount = 0;
	this.attrHash = new Object();
	this.subElems = new Array(); 

	function getTagString(){
		start = '<' + this.tagNamee;

		for (var n in this.attrHash) {
			attribName = n;
			attribValue = this.attrHash[n];
			attribStr = ' ' + attribName + '="' + attribValue + '"';
			start = start + attribStr;
		}
		start = start + '/>';
		return start;
	}

	function setAttribute(name, value){
		this.attrHash[name] = value;
	}

	function getAttribute(name){
		return this.attrHash[name];
	}

	function addSubElement(subtagElem){
		len = this.subElems.length;
		this.subElems[len] = subtagElem;
	}

	this.setAttribute = setAttribute;
	this.getAttribute = getAttribute;
	this.getTagString = getTagString;
	this.addSubElement = addSubElement;
}


function logIt(evt, num)
{
	var val = 0;
	var mainWin = document.getElementById("debugWindow");
	if(!mainWin) return;

	if(typeof(num)!="undefined"){
		val = num;
	}
	str = "debugW" + val;

	dw = document.getElementById(str);
	if(dw){
		dw.innerHTML += evt + '<br/>';
		dw.doScroll("scrollbarPageDown");
	}else{
		var newButton = document.createElement("button");
		newButton.innerHTML ="Clear";
		newButton.attachEvent("onclick", clearForm); 
		newButton.setAttribute("id2",str);

		var newButton2 = document.createElement("button");
		newButton2.innerHTML ="Hide";
		newButton2.attachEvent("onclick", toggleDebug); 
		newButton2.setAttribute("id2",str);

		mainWin.appendChild(newButton);
		mainWin.appendChild(newButton2);
		
		var newDebug = document.createElement("div");
		newDebug.setAttribute("id", str);
		newDebug.className="debugWin";
		mainWin.appendChild(newDebug);
		newDebug.innerHTML += evt + '<br/>';
	}
}

function clearForm(evt){
	elem = window.event.srcElement;
	str = elem.id2;
	dw = document.getElementById(str);
	if(dw){
		dw.innerHTML ="";
	}
}

function toggleDebug(evt){
	elem = window.event.srcElement;
	str = elem.id2;
	dw = document.getElementById(str);
	if(dw){
		if(dw.style.display == "none"){
			dw.style.display = "block";
			elem.innerHTML = "Hide";
		}else{
			dw.style.display = "none";
			elem.innerHTML = "Show";
		}
	}

}


function seekSliderMouseUp(obj)
{
	vid = getVideo(obj);
	if(vid == null){
		return true;
	}

	if (vid.bsliderDown) 
	{
		if (vid.currentEntry != null && vid.currentEntry.timelineid != null) {
			currentTimeline = document.getElementById(vid.currentEntry.timelineid);
			currentTimeline.pauseElement();
		}
		vid.animationTimeline.pauseElement();
		svgPause(vid.videoID);
		var beforePaused = vid.moviePaused;
		vid.moviePaused = true;

		var seekt = vid.slider.value / 100;
		if (seekt > 1) {
			seekt = 1;
		}
		vid.timePosition = seekt * 100;

		seekTimeline(obj, seekt);
		vid.bsliderDown = false;

		if (seekt < 1) {
		} 
		else {
			vid.movieFinished = true;
			beforePaused = true;
		}

		if (!beforePaused) {
			if (vid.playTimerID != null) {
				clearTimeout(vid.playTimerID);
				vid.playTimerID = null;
			}

			vid.playTimerID = setTimeout("playEventAfter('" + vid.videoID + "')", 300);
		}
	}
}



function seekSliderMouseDown(obj)
{
	vid = getVideo(obj);
	vid.bsliderDown = true;
	vid.bSeekInProgress = true;

	vid.slider.scrollXvalue = document.body.scrollLeft;
	vid.slider.scrollYvalue = document.body.scrollTop;
}



function volumeSliderMouseUp(obj)
{
	vid = getVideo(obj);

	if ((!INITIALIZED) || (vid==null)) {
		return true;
	}

	if (vid.movieStarted && vid.bsliderDownV) {
		slider = document.getElementById(vid.videoID + "_vSlider");
		vol = parseInt(slider.value);
		vid.CURRENTVOL = vol;
		slider.title = vol;

		if (!vid.bMovieMute) {
			movie = document.getElementById(vid.currentEntry.movieid);
			movie.volume = vol;
		}
		vid.bsliderDownV = false;
	}
}

function volumeSliderMouseDown(obj)
{
	vid = getVideo(obj);
	vid.bsliderDownV = true;

	vid.vSlider.scrollXvalue = document.body.scrollLeft;
	vid.vSlider.scrollYvalue = document.body.scrollTop;
}


function setBaseResource(str, bControlShow)
{
	BASERESOURCE = str;

	if (bControlShow == "true") 
	{
		playImgOn.src   = BASERESOURCE + "pause_On.gif";
		playImgOff.src  = BASERESOURCE + "pause_Off.gif";
		playImgOver.src = BASERESOURCE + "pause_Over.gif";
		pauseImgOn.src   = BASERESOURCE + "play_On.gif";
		pauseImgOff.src  = BASERESOURCE + "play_Off.gif";
		pauseImgOver.src = BASERESOURCE + "play_Over.gif";

		stopImgOn.src   = BASERESOURCE + "stop_On.gif";
		stopImgOff.src  = BASERESOURCE + "stop_Off.gif";
		stopImgOver.src = BASERESOURCE + "stop_Over.gif";
		prevImgOn.src   = BASERESOURCE + "back_On.gif";
		prevImgOff.src  = BASERESOURCE + "back_Off.gif";
		prevImgOver.src = BASERESOURCE + "back_Over.gif";
		nextImgOn.src   = BASERESOURCE + "forward_On.gif";
		nextImgOff.src  = BASERESOURCE + "forward_Off.gif";
		nextImgOver.src = BASERESOURCE + "forward_Over.gif";
		repeatImgOn.src   = BASERESOURCE + "repeat_On.gif";
		repeatImgOff.src  = BASERESOURCE + "repeat_Off.gif";
		repeatImgOver.src = BASERESOURCE + "repeat_Over.gif";
		speedFastOn.src   = BASERESOURCE + "speedFast_On.gif";
		speedFastOff.src  = BASERESOURCE + "speedFast_Off.gif";
		speedFastOver.src = BASERESOURCE + "speedFast_Over.gif";
		speedSlowOn.src   = BASERESOURCE + "speedSlow_On.gif";
		speedSlowOff.src  = BASERESOURCE + "speedSlow_Off.gif";
		speedSlowOver.src = BASERESOURCE + "speedSlow_Over.gif";
		soundImgOn.src   = BASERESOURCE + "sound_On.gif";
		soundImgOff.src  = BASERESOURCE + "sound_Off.gif";
		soundImgOver.src = BASERESOURCE + "sound_Over.gif";

		stepBackImgOn.src   = BASERESOURCE + "stepBack_On.gif";
		stepBackImgOff.src  = BASERESOURCE + "stepBack_Off.gif";
		stepBackImgOver.src = BASERESOURCE + "stepBack_Over.gif";
		stepForwardImgOn.src   =  BASERESOURCE + "stepForward_On.gif";
		stepForwardImgOff.src  =  BASERESOURCE + "stepForward_Off.gif";
		stepForwardImgOver.src =  BASERESOURCE + "stepForward_Over.gif";

		showFullImgOn.src   = BASERESOURCE + "showFull_On.gif";
		showFullImgOff.src  = BASERESOURCE + "showFull_Off.gif";
		showFullImgOver.src = BASERESOURCE + "showFull_Over.gif";
	}
}


function imgSwap(id, imagesrc)
{
	theImg = document.getElementById(id);
	theImg.setAttribute("src", imagesrc);
}


function overButton(obj, overFlag) 
{
	var length = obj.src.length;
	var endPos = length -1;
	var c;
	var objSrc;

	for (var i=endPos; i >= 0; i--) {
		c = obj.src.charAt(i);
		if (c == '_') {
			objSrc = obj.src.substring(0,i);
			break;
		}
	}

	if (overFlag == 'over' && obj.src == objSrc + "_Off.gif") {
		imgSwap(obj.id, objSrc + "_Over.gif");
	} else if (overFlag == 'out' && obj.src == objSrc + "_Over.gif") {
		imgSwap(obj.id, objSrc + "_Off.gif");
	}
}



function playDown(obj)
{
	var vid = getVideo(obj);
	
	if (!videoIsActive(vid.videoID)) {
		return;
	}

	if ((vid.moviePaused) || (!vid.movieStarted)){
		imgSwap(vid.videoID + "_playButton", pauseImgOn.src);
	} else{
		imgSwap(vid.videoID + "_playButton", playImgOn.src);
	}

	return true;
}


function pauseUp(obj)
{
	var vid = getVideo(obj);
	
	if (!vid.movieStarted) {
		vid.stopCommand = 1;
		return false;
	}
	if (checkTimer(vid) == false) {
		imgSwap(vid.videoID + "_playButton", playImgOff.src);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'Đ';
		return;
	}
	

	if (!vid.moviePaused && vid.movieStarted) {
		imgSwap(vid.videoID + "_playButton", playImgOff.src);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'Đ';

		if (vid.currentEntry.timelineid != null) {
			currentTimeline = document.getElementById(vid.currentEntry.timelineid);
			currentTimeline.pauseElement();
		}
		vid.animationTimeline.pauseElement();
		svgPause(vid.videoID);
		vid.moviePaused = true;
	}
}


function pausePreview(obj) 
{
	var vid = getVideo(obj);
	if (vid != null) {
		if (vid.currentEntry.timelineid != null) {
			currentTimeline = document.getElementById(vid.currentEntry.timelineid);
			currentTimeline.pauseElement();
		}
		vid.animationTimeline.pauseElement();
		svgPause(vid.videoID);
		vid.moviePaused = true;
	}
}


function checkTimer(vid)
{
	if (vid == null) {
		return false;
	}

	if (vid.playTimerID != null) {
		clearTimeout(vid.playTimerID);
		vid.playTimerID = null;
		return false;
	}

	return true;
}




function playMovie(obj)
{
	var vid = getVideo(obj);
	
	if (vid.playTimerID != null) {
		clearTimeout(vid.playTimerID);
		vid.playTimerID = null;
	} 
	
	if (!videoIsActive(vid.videoID)) {
		return;
	}

	if (!vid.movieStarted) {
		beginMovie(obj);
		vid.moviePaused = false;

		imgSwap(vid.videoID + "_playButton", pauseImgOff.src);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'ꎞ~';

		return true;
	}

	if (vid.movieFinished && vid.timePosition == 100) {
		stopElements(obj);
		vid.movieFinished = false;
		vid.moviePaused = true;

		str = "playUp('" + vid.videoID + "')";
		vid.playTimerID = setTimeout(str, 300);

		imgSwap(vid.videoID + "_playButton", pauseImgOff.src);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'ꎞ~';

		return true;
	}

	if (vid.moviePaused) {

		if (vid.currentEntry.timelineid != null) {
			currentTimeline = document.getElementById(vid.currentEntry.timelineid);
			currentTimeline.resumeElement();
		}
		vid.animationTimeline.resumeElement();
		svgResume(vid.videoID);
		vid.movieFinished = false;
		vid.moviePaused = false;

		imgSwap(vid.videoID + "_playButton", pauseImgOff.src);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'ꎞ~';

		return true;
	}

	return false;
}


function playUp(obj)
{
	var vid = getVideo(obj);

	if (!videoIsActive(vid.videoID)) {
		return;
	}

	if (playMovie(obj)) {
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'ꎞ~';
		return true;
	} else{
		pauseUp(obj);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'Đ';
	}
}




function stopDown(obj)
{
	var vid = getVideo(obj);
	if (!vid.movieStarted) {
		vid.stopCommand = 2;
		return false;
	}

	if (checkTimer(vid) == false) {
		imgSwap(vid.videoID + "_playButton", playImgOff.src);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'Đ';
		return;
	}

	imgSwap(vid.videoID + "_stopButton", stopImgOn.src);
	stopElements(obj);
}

function stopUp(obj)
{
}

function endMovie(obj)
{
	var vid = getVideo(obj);
	vid.bMovieIsActive = false;
	stopDown(obj);
}


function prevDown(obj)
{
	var vid = getVideo(obj);
	imgSwap(vid.videoID + "_prevButton", prevImgOn.src);
}

function prevUp(obj)
{
	var vid = getVideo(obj);
	var img = document.getElementById(vid.videoID + "_prevButton");

	imgSwap(vid.videoID + "_prevButton", prevImgOn.src);
	imgSwap(vid.videoID + "_prevButton", prevImgOff.src);
	seekToPrevScene(obj);
}


function nextDown(obj)
{
	var vid = getVideo(obj);
 	imgSwap(vid.videoID + "_nextButton", nextImgOn.src);
}

function nextUp(obj)
{
	var vid = getVideo(obj);
	var img = document.getElementById(vid.videoID + "_nextButton");

	imgSwap(vid.videoID + "_nextButton", nextImgOff.src);
	seekToNextScene(obj);
}




function repeatDown(obj)
{
	var vid = getVideo(obj);

	if (!vid.bRepeat){
	 	imgSwap(vid.videoID + "_repeatButton", repeatImgOn.src);
		vid.bRepeat = true;
	} else {
	 	imgSwap(vid.videoID + "_repeatButton", repeatImgOff.src);
		vid.bRepeat = false;
	}
}

function repeatUp(obj)
{
	return true;
}


function soundDown(obj)
{
	var vid = getVideo(obj);
	imgSwap(vid.videoID + "_soundButton", soundImgOff.src);

	if (!vid.bMovieMute) {
		if (vid.currentEntry) {
			var timeline = document.getElementById(vid.currentEntry.timelineid);
			if (timeline.volume != 100) {
				timeline.volume = 100;
			}
			var movie = document.getElementById(vid.currentEntry.movieid);
			movie.volume = 0;
			vid.bMovieMute = true;
		}
	} 
	else {
		if (vid.currentEntry) {
			var timeline = document.getElementById(vid.currentEntry.timelineid);
			if (timeline.volume != 100) {
				timeline.volume = 100;
			}
			var movie = document.getElementById(vid.currentEntry.movieid);
			movie.volume = vid.CURRENTVOL;
			vid.bMovieMute = false;
		}
	}
}

function soundUp(obj)
{
	var vid = getVideo(obj);
	if (!vid.bMovieMute) {
		imgSwap(vid.videoID + "_soundButton", soundImgOn.src);
		var soundButton = document.getElementById(vid.videoID + "_soundButton");
		soundButton.title = 'ON';
	} else {
		imgSwap(vid.videoID + "_soundButton", soundImgOff.src);
		var soundButton = document.getElementById(vid.videoID + "_soundButton");
		soundButton.title = 'OFF';
	}
}



function speedFastUp(obj)
{
	var vid = getVideo(obj);
	if (vid.CURRENTSPEED < 2.0) {
		var img = document.getElementById(vid.videoID + "_fastButton");
		imgSwap(vid.videoID + "_fastButton", speedFastOff.src);
		if (!vid.movieFinished) {
			vid.speedChange(1);
		}
	}
	return true;
}

function speedFastDown(obj)
{
	var vid = getVideo(obj);
	if (vid.CURRENTSPEED < 2.0) {
		imgSwap(vid.videoID + "_fastButton", speedFastOn.src);
	}
	return true;
}


function speedSlowUp(obj)
{
	var vid = getVideo(obj);
	if (vid.CURRENTSPEED > 0.55) {
		var img = document.getElementById(vid.videoID + "_slowButton");
		imgSwap(vid.videoID + "_slowButton", speedSlowOff.src);
		if (!vid.movieFinished) {
			vid.speedChange(-1);
		}
	}
	return true;
}

function speedSlowDown(obj)
{
	var vid = getVideo(obj);
	if (vid.CURRENTSPEED > 0.55) {
		imgSwap(vid.videoID + "_slowButton", speedSlowOn.src);
	}
	return true;
}


function stepBackUp(obj)
{
	var vid = getVideo(obj);
	img = document.getElementById(vid.videoID + "_stepBackButton");

	imgSwap(vid.videoID + "_stepBackButton", stepBackImgOff.src);
	stepToTime(vid.videoID, -5);

	return true;
}

function stepBackDown(obj)
{
	var vid = getVideo(obj);
	imgSwap(vid.videoID + "_stepBackButton", stepBackImgOn.src);
	return true;
}

function stepForwardUp(obj)
{
	var vid = getVideo(obj);
	img = document.getElementById(vid.videoID + "_stepForwardButton");

	imgSwap(vid.videoID + "_stepForwardButton", stepForwardImgOff.src);
	stepToTime(vid.videoID, 5);

	return true;
}

function stepForwardDown(obj)
{
	var vid = getVideo(obj);
	imgSwap(vid.videoID + "_stepForwardButton", stepForwardImgOn.src);
	return true;
}


function resizeVideoToFSUp(obj)
{
	var vid = getVideo(obj);

	if (!videoIsActive(vid.videoID)) {
		return;
	}
	
	img = document.getElementById(vid.videoID + "_showFullButton");
	imgSwap(vid.videoID + "_showFullButton", showFullImgOff.src);
	linkTo("adica:video_fullscreen/" + vid.videoID);

	return true;
}

function resizeVideoToFSDown(obj)
{
	var vid = getVideo(obj);
	imgSwap(vid.videoID + "_showFullButton", showFullImgOn.src);
	return true;
}




function getTime()
{
	if (INITIALIZED) {
		for (var hybridVideo in videolist) {
			if (!videolist[hybridVideo].animation.currTimeState.isActive) {
				continue;
			}
			updateDisplay(videolist[hybridVideo]);
		}
	}
}


var previousTime = 0;

function updateDisplay(hvid)
{
	if ((hvid.movieStarted) && (!hvid.bsliderDown) && (!hvid.bSeekInProgress)) 
	{
		var t = hvid.animation.currTimeState.segmentTime;
		if (t > hvid.TOTALTIME) {
			t = hvid.TOTALTIME;
		}

		if (hvid.currentEntry != null && t > 5.0) 
		{
			var movieID = hvid.currentEntry.movieid;
			var videoA = document.getElementById(movieID);
			
			var movieTime = videoA.currTimeState.segmentTime;
			var sceneStart = hvid.currentEntry.begintime;
			var currentMovieTime = movieTime - sceneStart;
			currentMovieTime = Math.round(currentMovieTime * 1000) / 1000;

			var seekTime = currentMovieTime + hvid.currentEntry.hybridStartTime;
			seekTime = Math.round(seekTime * 1000) / 1000;

			if (previousTime != movieTime) 
			{
				var sa = t - seekTime;
				if (currentMovieTime > 0 && sa > 0.3) {
					svgSeek(hvid.videoID, seekTime);
					hvid.animation.seekActiveTime(seekTime);
				}
			}
			previousTime = movieTime;
		}

		var p = t / hvid.TOTALTIME;
		var slideVal = parseInt(p * 100);
		if (slideVal == 99) {
			slideVal = 100;
		}
		hvid.slider.value = slideVal;
		hvid.slider.title = slideVal;
		hvid.timePosition = slideVal;

		currentTimePosition[hvid.videoID] = t;
	}
}


function setSpeed(videoID, num)
{
	vid = getVideo(videoID);
	if (vid) {
		vid.CURRENTSPEED = num;
		vid.updateSpeed();
	} else {
	}
}



function stopButtonRecover(videoID)
{
	var vid = getVideo(videoID);

	if (vid.stopBtnTimerID != null) {
		clearTimeout(vid.stopBtnTimerID);
		vid.stopBtnTimerID = null;
	}

	imgSwap(vid.videoID + "_stopButton", stopImgOff.src);
	imgSwap(vid.videoID + "_repeatButton", repeatImgOff.src);
	imgSwap(vid.videoID + "_playButton", playImgOff.src);
	imgSwap(vid.videoID + "_soundButton", soundImgOn.src);
	var soundButton = document.getElementById(vid.videoID + "_soundButton");
	soundButton.title = 'ON';

	var playButton = document.getElementById(vid.videoID + "_playButton");
	playButton.title = 'Đ';
}


function stopElements(obj)
{
	var vid = getVideo(obj);
	
	if (vid.currentEntry == null) {
		return;
	}

	vid.stopBtnTimerID = setTimeout("stopButtonRecover('" + vid.videoID + "')", 100);

	vid.bRepeat = false;
	vid.bMovieMute = false;
	var movie = document.getElementById(vid.currentEntry.movieid);
	movie.volume = vid.CURRENTVOL;

	vid.movieStarted = false;
	vid.moviePaused  = true;
	vid.movieFinished = true;

	var timeA = document.getElementById(vid.videoID + "_timelineA");
	var timeB = document.getElementById(vid.videoID + "_timelineB");

	timeA.endElement();
	timeB.endElement();

	//vid.animation.endElement();
	vid.animationTimeline.endElement();

	vid.animationTimeline.beginElement();
	vid.animationTimeline.pauseElement();

	svgStop(vid.videoID);

	vid.currentEntry = null;
	vid.currentScene = null;
	vid.slider.value = 0;
	vid.slider.title = 0;
	vid.timePosition = 0;
	vid.currentSpeedIndex = vid.speedDefault;
	vid.CURRENTSPEED = 1.0;

	clearInterval(vid.svgTimerID);
	vid.bSVGTimerSet = false;

	diva = document.getElementById(vid.videoID + "_divA");
	divb = document.getElementById(vid.videoID + "_divB");
	diva.style.visibility = "hidden";
	divb.style.visibility = "hidden";

	vid.currentEntry = vid.playlist[0];
	vid.currentEntry.timelineid = vid.videoID + "_timelineA";
	vid.currentEntry.divid = vid.videoID + "_divA";
	vid.currentEntry.movieid = vid.videoID + "_videoA";
	
	if (vid.playTimerID != null) {
		clearTimeout(vid.playTimerID);
		vid.playTimerID = null;
	}
	if (vid.seekS2TimerID != null) {
		clearTimeout(vid.seekS2TimerID);
		vid.seekS2TimerID = null;
	}

	preloader(vid.videoID);
}


function isImage(str)
{
	if(typeof(str)=="string"){
		str = str.toLowerCase() 
		if( (str.indexOf(".gif")!= -1) || (str.indexOf(".jpg") != -1) || (str.indexOf(".bmp") != -1)){
			return true;
		}
	}
	return false;
}





var m_videoID = null;
var m_height = null;
var m_width = null;
var m_top = null;
var m_left= null;
var m_uicolor = null;
var m_bPlay = null;
var m_bStop = null;
var m_bSeek = null;
var m_bVol = null;
var m_bSpeed = null;
var m_bPrevSkip = null;
var m_bNextSkip = null;
var m_bRepeat = null;
var m_bTime = null;
var m_bMute = null;
var m_bStep = null;
var m_bFull = null;

function uiReset()
{
	if (m_videoID != null) {
		uisetup(m_videoID, m_height, m_width, m_top, m_left, m_uicolor, m_bPlay, m_bStop, m_bSeek, m_bVol, m_bSpeed, m_bPrevSkip, m_bNextSkip, m_bRepeat, m_bTime, m_bMute, m_bStep, m_bFull, 2);
	}
}



function uisetup(videoID, height, width, top, left, uicolor, bPlay, bStop, bSeek, bVol, bSpeed, bPrevSkip, bNextSkip, bRepeat, bTime, bMute, bStep, bFull, bEvent)
{
	if (bEvent == 0 || bEvent == 1) {
		m_videoID = videoID;
		m_height = height;
		m_width = width;
		m_top = top;
		m_left= left;
		m_uicolor = uicolor;
		m_bPlay = bPlay;
		m_bStop = bStop;
		m_bSeek = bSeek;
		m_bVol = bVol;
		m_bSpeed = bSpeed;
		m_bPrevSkip = bPrevSkip;
		m_bNextSkip = bNextSkip;
		m_bRepeat = bRepeat;
		m_bTime = bTime;
		m_bMute = bMute;
		m_bStep = bStep;
		m_bFull = bFull;
	} 

	if (videoLevel == 1) {
	   bMute = false;
	   bVol  = false;
	}

	requestedWidth[videoID] = width;
	requestedHeight[videoID] = height;

	topBar = document.getElementById(videoID + "_MenuBar");

	var panel = document.getElementById(videoID + "_ControlPanel");
	panel.style.display = "block";

	uiSlider = document.getElementById(videoID + "_oSlider");
	uiVSlider = document.getElementById(videoID + "_vSlider");

	panel.style.top = top;
	panel.style.left = left;

	if (isImage(uicolor)) {
		panel.style.backgroundColor = "transparent";
		uiSlider.style.backgroundColor = "transparent";
		uiVSlider.style.backgroundColor = "transparent";
		panel.style.backgroundImage = "url('" + uicolor + "')";
	} else{
		panel.style.backgroundColor = uicolor;
		uiSlider.style.backgroundColor = uicolor;
		uiVSlider.style.backgroundColor = uicolor;
	}

	uitoggle(videoID + "_playButton", bPlay);
	uitoggle(videoID + "_stopButton", bStop);
	uitoggle(videoID + "_oSlider", bSeek);

	ctrlObj = document.getElementById(videoID + "_oLeft");
	if (ctrlObj) {
		if(bSeek){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}

	ctrlObj = document.getElementById(videoID + "_oRight");
	if(ctrlObj){
		if(bSeek){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}

	uitoggle(videoID + "_prevButton", bPrevSkip);
	uitoggle(videoID + "_nextButton", bNextSkip);
	uitoggle(videoID + "_repeatButton", bRepeat);
	uitoggle(videoID + "_slowButton", bSpeed);
	uitoggle(videoID + "_fastButton", bSpeed);
	uitoggle(videoID + "_soundButton", bMute);
	uitoggle(videoID + "_vSlider", bVol);
	uitoggle(videoID + "_stepBackButton", bStep);
	uitoggle(videoID + "_stepForwardButton", bStep);
	uitoggle(videoID + "_showFullButton", bFull);


	ctrlObj = document.getElementById(videoID + "_vLeft");
	if (ctrlObj) {
		if(bVol){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}
	ctrlObj = document.getElementById(videoID + "_vRight");
	if (ctrlObj) {
		if(bVol){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}

	r2Count = (bPrevSkip? 1:0) + (bNextSkip? 1:0) + (bRepeat? 1:0) + (bSpeed? 2:0) + (bMute? 1:0) + (bVol? 1:0) + (bStep? 2:0) + (bFull? 1:0);

	var callString = "widthCalculate('" + videoID + "'," + bEvent + ");";
	setTimeout(callString, 500);
	heightCalculate(videoID, bEvent);

	ctrlObj = document.getElementById(videoID + "_lbot");
	if(ctrlObj){
		if(bSeek){
			ctrlObj.style.top = 45;
		}else{
			ctrlObj.style.top = 21;
		}
	}
	ctrlObj = document.getElementById(videoID + "_rbot");
	if(ctrlObj){
		if(bSeek){
			ctrlObj.style.top = 45;
		}else{
			ctrlObj.style.top = 21;
		}
		ctrlObj.style.left = width - 7;
	}
}

function uitoggle(idName, show)
{
	ctrlObj = document.getElementById(idName);
	if (ctrlObj) {
		if (show) {
			ctrlObj.style.display = 'inline';
			if (ctrlObj.id == 'oSlider') {
				ctrlObj.style.width = "50px";
				ctrlObj.style.display = "inline";
			}
			uiHashtable[idName] = parseInt(ctrlObj.currentStyle.width);
		} else {
			ctrlObj.style.display = 'none';
			uiHashtable[idName] = 0;
		}
	}
}


function widthCalculate(videoID, bEvent)
{
	var vid = getVideo(videoID);
	var row1Width = 6;
	for(var i=0; i<firstRow.length; i++){
		width = uiHashtable[videoID + "_" + firstRow[i]];
		row1Width += width;
	}
	var row2Width = 6;
	var row2Count = 0;
	for(var i=0; i<secondRow.length; i++){
		width = uiHashtable[videoID + "_" + secondRow[i]];
		row2Width += width;
		if(width > 0){
			row2Count++;
		}
	}

	minWidth = (row1Width > row2Width) ? row1Width : row2Width;
	
	if (bEvent != 0) {
		finalWidth = requestedWidth[videoID];
	} else {
		finalWidth = (minWidth > requestedWidth) ? minWith : requestedWidth[videoID];
	}

	var controlPanel = document.getElementById(videoID + "_ControlPanel");
	var borderWidth = parseInt(controlPanel.currentStyle.borderWidth);

	borderWidth = borderWidth * 2 + 4;

	slider = document.getElementById(videoID + '_oSlider');
	vslider = document.getElementById(videoID + '_vSlider');
	vslider.style.width = 26;
	
	vslider.SetTicks();
	vslider.value = 100;
	vslider.title = '100';

	var bSliderExist = false;
	if (slider) {
		bSliderExist = (slider.offsetWidth > 0) ? true : false;
	}

	if ((row1Width < finalWidth) && (bSliderExist)) {
		difference = requestedWidth[videoID] - row1Width;
		originalWidth = slider.offsetWidth;
		newWidth = originalWidth + difference - borderWidth;
		slider.style.width = newWidth;
	}
	else if (bSliderExist && bEvent != 0) {
		difference = requestedWidth[videoID] - row1Width;
		originalWidth = slider.offsetWidth;
		newWidth = originalWidth + difference - borderWidth;
		slider.style.width = newWidth;
	}
		
	if ((!bSliderExist)){
		panel = document.getElementById(videoID + '_MenuBar');
	}

	ctrlPanel = document.getElementById(videoID + '_ControlPanel');
	ctrlPanel.style.visibility = "visible";
	ctrlPanel.style.display = "block";
}


function heightCalculate(videoID, bEvent)
{
	var controlHeight = 0;
	controlPanel = document.getElementById(videoID + '_ControlPanel');
	controlHeight = controlPanel.offsetHeight;

	if (bEvent != 0) {
		finalHeight = requestedHeight[videoID];
	} else {
		finalHeight = (controlHeight > requestedHeight[videoID]) ? controlHeight : requestedHeight[videoID];
	}

	var borderHeight = parseInt(controlPanel.currentStyle.borderWidth);
	borderHeight = borderHeight * 2;

	controlPanel.style.height = finalHeight - borderHeight;
}


function addPlayEntry(videoID, indexNum, movieSrc, start, end)
{
	if (videoLevel != 0) {
		movieSrc = "";
	}

	var vid;
	if (videolist[videoID] == null) {
		vid = new videoEntry(videoID);
		videolist[videoID] = vid;
	} else {
		vid = videolist[videoID];
	}


	playentry = new playEntry(videoID, indexNum, movieSrc);
	playentry.setRange(start, end);

	if (indexNum == 0) {
		playentry.divid = videoID + "_divA";
		playentry.timelineid = videoID + "_timelineA";
		playentry.movieid = videoID + "_videoA";
		
		initProgressList[videoID + "_timelineA"] = 0;
		initProgressList[videoID + "_timelineB"] = 0;
	}
	vid.playlist[indexNum] = playentry;
}


function addSceneEntry(videoID, indexNum, start, end)
{
	var vid;
	if (videolist[videoID] == null) {
		vid = new videoEntry(videoID);
		videolist[videoID] = vid;
	} else {
		vid = videolist[videoID];
	}

	sceneentry = new sceneEntry(videoID, indexNum, start, end);
	vid.scenelist[indexNum] = sceneentry;
}



function updateScene(updateVidID, starttime)
{
	var updateVid = getVideo(updateVidID);
	var bSceneFound = false;
	var scene = null;
	
	for (var i=0; i<updateVid.scenelist.length; i++) {
		scene = updateVid.scenelist[i];
		if ((starttime >= scene.begin) && (starttime < scene.end)) {
			updateVid.currentScene = scene;
			bSceneFound = true;
			break;
		}
	}

	if (!bSceneFound) {
		updateVid.currentScene = null;
		updateIndex(updateVid, updateVid.currentEntry.index + ":-");
	}
	else{
		updateIndex(updateVid, updateVid.currentEntry.index + ":" + updateVid.currentScene.index);
		if (updateVid.scenetime) {
			updateVid.scenetime.dur = updateVid.currentScene.end;
		}
	}
}



function sceneEnd(endobj)
{
	var vid = getVideo(endobj);
	var t = vid.animation.currTimeState.segmentTime;

	if (vid.NEXTDISABLE) {
		return;
	}

	if ((vid.bRepeat) && (!vid.bSeekInProgress))
	{
		nextScene(vid.videoID, 0);
		return;
	}

	if ((vid.currentEntry) && (vid.movieStarted != false) && (vid.moviePaused != true))
	{
		updateScene(vid.videoID, t);
	}
}



function preloader(videoID)
{
	var firstMovie = document.getElementById(videoID + "_videoA");
	var timeline1 = document.getElementById(videoID + "_timelineA");
	var divid1 = document.getElementById(videoID + "_divA");

	var vid = videolist[videoID];
	var playentry = vid.playlist[0];
	var moviesrc = playentry.srcLocation;
	var endTime = "" + playentry.endtime + "s";

	firstMovie.src = moviesrc;
	firstMovie.dur = endTime;

	timeline1.beginElement();
	timeline1.beginElement();

	divid1.style.visibility = "visible";
	initProgressList[videoID + "_timelineA"] = 0;
}



function autoStart(vidid, bStart, timeStart)
{
	vid = videolist[vidid];
	vid.bAutoStart = bStart;

	if(!bStart) return;

	if((bStart) && (typeof(timeStart)!="undefined")){
		vid.autoStartTime = (timeStart < 200) ? 200 : timeStart;
	}else{
		vid.autoStartTime = 200;
	}
}


function initializeMovies()
{
	for (var vid in videolist) {
		adjustWindows(vid);
		calcTimes(vid);
		preloader(vid);
		currentTimePosition[vid.videoID] = 0;
	}

	listUI();
	INITIALIZED = true;
}


function adjustWindows(vid)
{
	movieDiv = document.getElementById(vid);
	divA = document.getElementById(vid + "_divA");
	divB = document.getElementById(vid + "_divB");
	divC = document.getElementById(vid + "_svgDiv");

	w = movieDiv.currentStyle.width;
	h = movieDiv.currentStyle.height;

	divA.style.position="absolute";
	divA.style.visibility="hidden";
	divA.style.top = "0px";
	divA.style.left ="0px";
	divA.style.width = "100%";
	divA.style.height = "100%";

	divB.style.position="absolute";
	divB.style.visibility="hidden";
	divB.style.top = "0px";
	divB.style.left ="0px";
	divB.style.width = "100%";
	divB.style.height = "100%";

	if (divC) 
	{
		divA.style.position="absolute";
		divA.style.visibility="visible";
		divA.style.top = "0px";
		divA.style.left ="0px";
		divA.style.width = "100%";
		divA.style.height = "100%";
	}

	if ((w == "auto") || (h == "auto")) {
		w = defaultWIDTH;
		h = defaultHEIGHT;
	}

	topPos = movieDiv.currentStyle.top;
	leftPos = movieDiv.currentStyle.left;

	if (svgSupport[vid]) {
		var svgdiv = document.getElementById(vid + "_svgDiv");
		var svgplayer = document.getElementById(vid + "_svg");
		svgdiv.style.top = "0px";
		svgdiv.style.left = "0px";
		svgdiv.style.width = w;
		svgdiv.style.height = h;

		var svgdoc = getSVGdoc2(vid);
		if (svgdoc != null) {
			var svgRoot = svgdoc.getDocumentElement();
			var boxStr = "0 0 " + parseInt(w) + " " + parseInt(h);
			svgRoot.setAttribute("viewBox", boxStr);
		}
	}

	videoElementA = document.getElementById(vid + "_videoA");
	videoElementB = document.getElementById(vid + "_videoB");
	videoElementA.style.width = "100%";
	videoElementA.style.height = "100%";
	videoElementB.style.width = "100%";
	videoElementB.style.height = "100%";
}



function waitload(waitVideoID)
{
		var themov = document.getElementById(waitVideoID + "_videoA");
		var ttimeline = document.getElementById(waitVideoID + "_timelineA");
		var tdivid = document.getElementById(waitVideoID + "_divA");
		var waitVid = videolist[waitVideoID];

		waitVid.bInitLoadComp = true;

		if (waitVid.movieStarted) {
			return true;
		}
		ttimeline.beginElement();
		ttimeline.pauseElement();

		if (!waitVid.bAutoStart) {
			waitVid.moviePaused = true;
			beginMovie(waitVideoID);

			if (waitVid.currentEntry.timelineid != null) {
				var currentTimeline = document.getElementById(waitVid.currentEntry.timelineid);
				currentTimeline.pauseElement();
			}
			waitVid.animationTimeline.beginElement();
			waitVid.animationTimeline.pauseElement();
			svgPause(waitVid.videoID);

			seekToTime(waitVideoID, 0.015);
		}
		else{
			imgSwap(waitVid.videoID + "_playButton", pauseImgOff.src);
			var playButton = document.getElementById(vid.videoID + "_playButton");
			playButton.title = 'Đ';

			waitVid.bAutoStart = false;
			waitVid.autoStartTime = 200;
			waitVid.moviePaused = false;

			beginMovie(waitVideoID);
		}
}



function zoomTO(zVideoID, zWidth, zHeight)
{
	var vidDiv = document.getElementById(zVideoID);
	var svgDiv = document.getElementById(zVideoID + "_svgDiv");
	var svgEmbed = document.getElementById(zVideoID + "_svg");

	var newWidth = parseInt(zWidth);
	var newHeight = 1;

	var originalWidth = vidDiv.offsetWidth;
	var originalHeight = vidDiv.offsetHeight;

	vidDiv.style.width = newWidth + "px";

	if(typeof(zHeight)=="undefined"){
		ratio = newWidth/originalWidth;
		newHeight = parseInt(originalHeight * ratio);
	}else{
		newHeight = parseInt(zHeight);
	}
	
	vidDiv.style.height = newHeight + "px";
	
	if(svgDiv){
		svgEmbed.width = newWidth;
		svgEmbed.height = newHeight;
		svgDiv.style.width = newWidth + "px";
		svgDiv.style.height = newHeight + "px";
	}
}

function zoomTO2(zVideoID, zWidth, zHeight)
{
	vidDiv = document.getElementById(zVideoID);
	svgDiv = document.getElementById(zVideoID + "_svgDiv");
	svgEmbed = document.getElementById(zVideoID + "_svg");

	var newWidth = parseInt(zWidth);
	var newHeight = 1;

	originalWidth = vidDiv.offsetWidth;
	originalHeight = vidDiv.offsetHeight;

	ratio = newWidth/originalWidth;

	if(typeof(zHeight)=="undefined"){
		newHeight = parseInt(originalHeight * ratio);
	}else{
		newHeight = parseInt(zHeight);
	}
	vidDiv.style.zoom =1.5;
	if(svgDiv){
	}
}


function wait(num){
	var td;
	var diff = 0;
	var theDate = new Date();
	while(diff < num) {
		var nowDate = new Date();
		diff = nowDate.getTime() - theDate.getTime();
	}
}

function uninit() {
	UNLOADING = true;
}


function getResumeTime(msg)
{
	if (INITIALIZED){
		var command = 'adica:record_videotime/';

		for (var hybridVideo in videolist) {
			var hvid = videolist[hybridVideo];
			var recordTime = 0;
			var videoState = 2;

			if (hvid.animation.currTimeState.isActive) {
				videoState = (hvid.movieFinished) ? 2 : (hvid.moviePaused) ? 1 : 0;
				if (videoState == 2 && hvid.timePosition == 100) {
					videoState = 3;
				}

				if (hvid.currentEntry != null) {
					var movieID = hvid.currentEntry.movieid;
					var videoA = document.getElementById(movieID);

					var movieTime = videoA.currTimeState.segmentTime;
					var sceneStart = hvid.currentEntry.begintime;
					var currentMovieTime = movieTime - sceneStart;
					currentMovieTime = Math.round(currentMovieTime * 1000) / 1000;

					recordTime = currentMovieTime + hvid.currentEntry.hybridStartTime;
					recordTime = Math.round(recordTime * 1000) / 1000;
				}
			}
			command += hvid.videoID + '@@' + recordTime + '@@' + videoState + '@@/';
		}
		linkTo(command);
	}
}





var zA = new Array();

function buffProgress(videoID, id) 
{
	var video = getVideo(videoID);

	if (video.currentEntry == null || video.currentEntry.movieid == null) {
		return;
	}
	var movieID = video.currentEntry.movieid;
	var videoA = document.getElementById(movieID);
	var progress = videoA.bufferingProgress;
	if (progress == null) {
		return;
	}

	var prog  = document.getElementById(id + "Prog");
	var gage  = document.getElementById(id + "Gage");
	var zone  = document.getElementById(id + "GageZone");
	var state = document.getElementById(id + "State");
	var percent = document.getElementById(id + "Percent");
	var kamiIndex  = document.getElementById(id + "KamiIndex");

	var nIndex = 0;

	zA[movieID] = videoA.currentFrame;

	prog.style.width = parseInt(progress * parseInt(gage.offsetWidth) / 100);
	if (videoA.isStreamed) {
		if (parseInt(prog.style.width) >= 2) {
			var size = parseInt(prog.style.width) - 2;
			prog.style.width = size;
		} 
	}
	if (prog.style.width >= gage.offsetWidth && gage.offsetWidth >= 0) {
		prog.style.width = gage.offsetWidth;
	}
	if (progress != 0) {
		percent.innerText = progress;
	}

	if (videoLevel != 0) {
		percent.innerText = "";
		var ct = video.animationTimeline.currTimeState.activeTime;
		for (i = 0; i < KamiTime.length; i++) {
			if (KamiTime[i] > ct) {
				break;
			}
		}
		if (i != KamiTime.length) {
			percent.innerText = parseInt(KamiTime[i] - ct);
			nIndex = i;
		}
	}


	state.innerText = "";

	if (video != null) {
		if (videoA.isStreamed && videoLevel == 0) {
			if (zA[movieID] != videoA.currentFrame ) {
				zA[movieID] = videoA.currentFrame;

				if (video.moviePaused || video.movieFinished) {
					state.innerText = "~";
				} else {
					state.innerText = "Đ";
				}

				if (initProgressList[video.currentEntry.timelineid] == 0) {
					initProgressList[video.currentEntry.timelineid] = 1;

					if (video.currentEntry.timelineid) {
						video.animationTimeline.pauseElement();
						currentTimeline = document.getElementById(video.currentEntry.timelineid);
						currentTimeline.pauseElement();
						svgPause(video.videoID);
						svgSeek(video.videoID, currentTimePosition[video.videoID] + 0.01);
						video.buffering = true;

						seekToTime(video.videoID, currentTimePosition[video.videoID] + 0.01);
					}
					return;
				}

				if (!video.moviePaused && !video.movieFinished && video.currentEntry.timelineid != null
					&& video.buffering == true) {
					svgSeek(video.videoID, currentTimePosition[video.videoID] + 0.01);

					currentTimeline = document.getElementById(video.currentEntry.timelineid);
					currentTimeline.resumeElement();
					video.animationTimeline.resumeElement();
					svgResume(video.videoID);

					video.buffering = false;
				}
			}
			else {
				if (video.moviePaused || video.movieFinished) {
					state.innerText = "~";
				} else {
					state.innerText = "ޯ̧";
				}

				var seekTime = currentTimePosition[video.videoID] + 0.01;

				video.animationTimeline.pauseElement();
				svgPause(video.videoID);
				svgSeek(video.videoID, seekTime);

				if ((!video.moviePaused && !video.movieFinished) && video.buffering == false) {
					seekToTime(video.videoID, seekTime);
				}
				video.buffering = true;
			}
		}
		else {
			if (video.moviePaused || video.movieFinished) {
				state.innerText = "~";
			} 
			else {
				state.innerText = "Đ";
				if (videoLevel == 1) {
					state.innerText = "ŋĐ";

					zone.style.width = "0%";
					kamiIndex.style.width = "50%";
					kamiIndex.style.textAlign = "center";
					kamiIndex.style.backgroundColor = "#ABABAE";
					total = KamiTime.length - 1;
					kamiIndex.innerText = nIndex + "/" + total;
				}
			}
		}
	}
}



function seekEvent(seekVidID, seektime, waitFlag, finalFlag, count) 
{
	var vid = getVideo(seekVidID);

	if (vid.bSeekEvent == false) {
		vid.bSeekEvent = true;
	} else {
		if (count >= 0) {
		} else {
			endWaitFunction(vid.videoID, waitFlag, finalFlag);
			return;
		}
	}

	var bWait = setWaitFunction2(seekVidID, seektime, waitFlag, finalFlag, "seekEvent", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("seekEvent('" + vid.videoID + "'," + seektime + "," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("seekEvent('" + vid.videoID + "'," + seektime + "," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	
	if (vid.movieStarted == true) {
		vid.eventExecFlag = true;
		seekEventExec(vid.videoID, seektime, waitFlag, finalFlag);
	}
	else {
		if (count < 2000) {
			setTimeout("seekEvent('" + seekVidID + "'," + seektime + "," + waitFlag + "," + finalFlag + "," + count + ")", 20);
			return;
		}
		else {
			endWaitFunction(vid.videoID, waitFlag, finalFlag);
		}
	}
}

function seekEventExec(obj, seektime, waitFlag, finalFlag) 
{
	var vid = getVideo(obj);
	
	if (!vid.movieStarted || vid.bMovieIsActive == false) {
		vid.stopCommand = 3;
	}
	
	if (vid.currentEntry != null && vid.currentEntry.timelineid != null) {
		currentTimeline = document.getElementById(vid.currentEntry.timelineid);
		currentTimeline.pauseElement();
	}
	vid.animationTimeline.pauseElement();
	svgPause(vid.videoID);
	var beforePaused = vid.moviePaused;
	vid.moviePaused = true;

	seekToTime(vid.videoID, seektime);

	if (beforePaused == true) {
		var moreSeek = seektime + SEEK_AFTER_CORRECT;
		if (vid.delayedSeekID != null) {
			setTimeout("delayedSeekToAnimate('" + vid.videoID + "'," + moreSeek + ")", 200);
		} else {
			if (vid.animation != null && vid.animation.currTimeState.isActive) {
				vid.animation.seekActiveTime(moreSeek);
			}
			svgSeek(vid.videoID, moreSeek);
		}
	}

	if (!beforePaused) {
		if (vid.playTimerID != null) {
			clearTimeout(vid.playTimerID);
			vid.playTimerID = null;
		}
		vid.playTimerID = setTimeout("playEventAfter('" + vid.videoID + "'," + waitFlag + "," + finalFlag + ")", 300);
	}
	else {
		if (vid.delayedSeekID != null) {
			setTimeout("endWaitFunction('" + vid.videoID + "'," + waitFlag + "," + finalFlag + ")", 200);
		} else { 
			endWaitFunction(obj, waitFlag, finalFlag);
		}
		vid.bSeekEvent = false;
	}
}


function delayedSeekToAnimate(obj, timeto)
{
	var vid = getVideo(obj);
	if (vid.animation != null && vid.animation.currTimeState.isActive) {
		vid.animation.seekActiveTime(timeto);
	}
	svgSeek(vid.videoID, timeto);
}


function playEvent(obj, waitFlag, finalFlag, count) 
{
	var vid = getVideo(obj);

	var bWait = setWaitFunction(obj, waitFlag, finalFlag, "playEvent", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("playEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("playEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	vid.eventExecFlag = true;
	playMovie(vid.videoID, waitFlag);

	endWaitFunction(obj, waitFlag, finalFlag);
}


function playEventAfter(obj, waitFlag, finalFlag) 
{
	var vid = getVideo(obj);
	
	if (vid.playTimerID != null) {
		clearTimeout(vid.playTimerID);
		vid.playTimerID = null;
	}

	vid.bSeekEvent = false;
	playMovie(vid.videoID);

	endWaitFunction(obj, waitFlag, finalFlag);
}



function pauseEvent(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	
	var bWait = setWaitFunction(obj, waitFlag, finalFlag, "pauseEvent", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("pauseEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("pauseEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}

	if (!vid.movieStarted || vid.bMovieIsActive == false) {
		vid.stopCommand = 1;
		endWaitFunction(obj, waitFlag, finalFlag);
		return false;
	}

	vid.eventExecFlag = true;
	if (vid.movieFinished) {
		return;
	} else {
		pauseUp(obj);
	}
	
	endWaitFunction(obj, waitFlag, finalFlag);
}



function resumeEvent(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	
	var bWait = setWaitFunction(obj, waitFlag, finalFlag, "resumeEvent", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("resumeEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("resumeEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	
	vid.eventExecFlag = true;
	if (vid.movieFinished) {
		return;
	} else {
		playMovie(obj);
	}
	endWaitFunction(obj, waitFlag, finalFlag);
}

function stopEvent(obj, waitFlag, finalFlag, count) 
{
	var vid = getVideo(obj);

	var bWait = setWaitFunction(obj, waitFlag, finalFlag, "stopEvent", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("stopEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("stopEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	
	if (!vid.movieStarted || vid.bMovieIsActive == false) {
		vid.stopCommand = 2;
		endWaitFunction(obj, waitFlag, finalFlag);
		return;
	}
	vid.eventExecFlag = true;
	stopElements(vid.videoID);

	endWaitFunction(obj, waitFlag, finalFlag);
}



function seekToPrevScene(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	
	var bWait = setWaitFunction(obj, waitFlag, finalFlag, "seekToPrevScene", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("seekToPrevScene('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("seekToPrevScene('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	
	if (!vid.movieStarted || vid.bMovieIsActive == false) {
		vid.stopCommand = 3;
	}

	vid.eventExecFlag = true;
	
	if (vid.currentEntry.timelineid != null) {
		currentTimeline = document.getElementById(vid.currentEntry.timelineid);
		currentTimeline.pauseElement();
	}
	vid.animationTimeline.pauseElement();
	svgPause(vid.videoID);
	var beforePaused = vid.moviePaused;
	vid.moviePaused = true;

	nextScene(vid.videoID, -1, beforePaused);

	if (!beforePaused) {
		if (vid.playTimerID != null) {
			clearTimeout(vid.playTimerID);
			vid.playTimerID = null;
		}
		vid.playTimerID = setTimeout("playEventAfter('" + vid.videoID + "'," + waitFlag + "," + finalFlag + ")", 300);
	} else {
		if (vid.delayedSeekID != null) {
			setTimeout("seekToPrevScene - endWaitFunction('" + vid.videoID + "'," + waitFlag + "," + finalFlag + ")", 200);
		} else {
			endWaitFunction(obj, waitFlag, finalFlag);
		}
	}
}


function seekToNextScene(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	
	var bWait = setWaitFunction(obj, waitFlag, finalFlag, "seekToNextScene", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("seekToNextScene('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("seekToNextScene('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	
	if (!vid.movieStarted || vid.bMovieIsActive == false) {
		vid.stopCommand = 3;
	}
	
	vid.eventExecFlag = true;
	
	if (vid.currentEntry.timelineid != null) {
		currentTimeline = document.getElementById(vid.currentEntry.timelineid);
		currentTimeline.pauseElement();
	}
	vid.animationTimeline.pauseElement();
	svgPause(vid.videoID);
	var beforePaused = vid.moviePaused;
	vid.moviePaused = true;

	nextScene(vid.videoID, 1, beforePaused);

	if (!beforePaused) {
		if (vid.playTimerID != null) {
			clearTimeout(vid.playTimerID);
			vid.playTimerID = null;
		}
		vid.playTimerID = setTimeout("playEventAfter('" + vid.videoID + "'," + waitFlag + "," + finalFlag + ")", 300);
	} else {
		if (vid.delayedSeekID != null) {
			setTimeout("endWaitFunction('" + vid.videoID + "'," + waitFlag + "," + finalFlag + ")", 200);
		} else { 
			endWaitFunction(obj, waitFlag, finalFlag);
		}
	}
}



function speedFast(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	
	var bWait = setWaitFunction(obj, waitFlag, finalFlag, "speedFast", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("speedFast('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("speedFast('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	
	vid.eventExecFlag = true;
		
	if (!vid.movieFinished) {
		vid.speedChange(1);
	}
	else {
		setTimeout("speedFast('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 20);
		return
	}
	
	endWaitFunction(obj, waitFlag, finalFlag);	
}


function speedSlow(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	
	var bWait = setWaitFunction(obj, waitFlag, finalFlag, "speedSlow", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("speedSlow('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("speedSlow('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	
	vid.eventExecFlag = true;
		
	if (!vid.movieFinished) {
		vid.speedChange(-1);
	}
	else {
		setTimeout("speedSlow('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 20);
		return
	}
	
	endWaitFunction(obj, waitFlag, finalFlag);	
}


function stepBackEvent(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	
	var bWait = setWaitFunction(obj, waitFlag, finalFlag, "stepBackEvent", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("stepBackEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("stepBackEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	
	vid.eventExecFlag = true;

	var t = vid.animation.currTimeState.segmentTime;
	var seektime = t - 5;
	if (seektime > vid.TOTALTIME) {
		seektime = vid.TOTALTIME;
	} else if (seektime < 0) {
		seektime = 0;
	}

	seekEventExec(vid.videoID, seektime, waitFlag, finalFlag);
}


function stepForwardEvent(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	
	var bWait = setWaitFunction(obj, waitFlag, finalFlag, "stepForwardEvent", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("stepForwardEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("stepForwardEvent('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	
	vid.eventExecFlag = true;
	
	var t = vid.animation.currTimeState.segmentTime;
	var seektime = t + 5;
	if (seektime > vid.TOTALTIME) {
		seektime = vid.TOTALTIME;
	} else if (seektime < 0) {
		seektime = 0;
	}

	seekEventExec(vid.videoID, seektime, waitFlag, finalFlag);
}



function soundChange(obj, vol, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	
	var bWait = setWaitFunction2(obj, vol, waitFlag, finalFlag, "soundChange", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("soundChange('" + vid.videoID + "'," + vol + "," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("soundChange('" + vid.videoID + "'," + vol + "," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	
	vid.eventExecFlag = true;
	
	if (!vid.bMovieMute && vol > 0) {
		if (vid.currentEntry) {
			var timeline = document.getElementById(vid.currentEntry.timelineid);
			timeline.volume = vol;
		}
	}
	
	endWaitFunction(obj, waitFlag, finalFlag);
}


function soundSwitch(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);

	var bWait = setWaitFunction(obj, waitFlag, finalFlag, "soundSwitch", count);
	if (bWait) {
		if (count == null || count == undefined) {
			count = 0;
			setTimeout("soundSwitch('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
		else if (count >= 0 && count < 1000) {
			count += 10;
			setTimeout("soundSwitch('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 10);
			return;
		}
	}
	
	soundChange(vid.videoID, 1);
	setTimeout("soundSwitchLater('" + vid.videoID + "'," + waitFlag + "," + finalFlag + "," + count + ")", 500);
}


function soundSwitchLater(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	vid.eventExecFlag = true;

	soundDown(obj);
	soundUp(obj);

	endWaitFunction(obj, waitFlag, finalFlag);
}




function setWaitFunction(obj, waitFlag, finalFlag, funcName, count)
{
	var vid = getVideo(obj);
	var funcStr = null;
	var bWaitFuncFlag = false;

	if (waitFlag != null && waitFlag != undefined && waitFlag > vid.timerFlag) 
	{
		bWaitFuncFlag = true;
	}
	else {
		if (vid.eventExecFlag == true) {
			bWaitFuncFlag = true;
		} else if (!vid.bInitLoadComp) {
			bWaitFuncFlag = true;
		} else if (vid.playTimerID != null) {
			bWaitFuncFlag = true;
		} else if (vid.seekSTimerID != null) {
			bWaitFuncFlag = true;
		} else if (vid.seekS2TimerID != null) {
			bWaitFuncFlag = true;
		}
	}
	
	return bWaitFuncFlag;

}



function setWaitFunction2(obj, param1, waitFlag, finalFlag, funcName, count)
{
	var vid = getVideo(obj);
	var funcStr = null;
	var bWaitFuncFlag = false;

	if (waitFlag != null && waitFlag != undefined && waitFlag > vid.timerFlag) 
	{
		bWaitFuncFlag = true;
	}
	else {
		if (vid.eventExecFlag == true) {
			bWaitFuncFlag = true;
		} else if (!vid.bInitLoadComp) {
			bWaitFuncFlag = true;
		} else if (vid.playTimerID != null) {
			bWaitFuncFlag = true;
		} else if (vid.seekSTimerID != null) {
			bWaitFuncFlag = true;
		} else if (vid.seekS2TimerID != null) {
			bWaitFuncFlag = true;
		}
	}
	
	return bWaitFuncFlag;
}


function endWaitFunction(obj, waitFlag, finalFlag) 
{
	var vid = getVideo(obj);
	vid.eventExecFlag = false;
	
	if (waitFlag != null && waitFlag != undefined && waitFlag >= 0) {
		vid.timerFlag = waitFlag + 1;
	}
	if (finalFlag != null && finalFlag != undefined && finalFlag == 1) {
		vid.timerFlag = 0;
	}
}


function videoIsActive(obj) 
{
	var vid = getVideo(obj);
	var elem = document.getElementById(vid.videoID);
	if (elem == null) {
		return false;
	}
	var disp = elem.getAttribute('style').display;
	var vis = elem.getAttribute('style').visibility;
	if (disp == "none" || vis == "hidden") {
		return false;
	}
	
	return true;
}



