window.setInterval("labelUpdate()", 400);

var BASERESOURCE = "";
var MANUAL_NAME = "";
var MAXTABS = 16;

for (var i=0; i<MAXTABS; i++) {
	delFusenUpdateToCookie(i);
}


function labelUpdate()
{
	var lock = getFusenLockFromCookie();
	if (lock == "Lock") {
		return;
	}

	var update = "";
	for (var n=0; n<MAXTABS; n++) {
		update = getFusenUpdateFromCookie(n);
		if (update != null && update != "") {

			if (update == "Add") {
				addNewTag(getCookie("FusenUpdatePageID"),getCookie("FusenUpdateTagID"),
					getCookie("FusenUpdateText"),getCookie("FusenUpdateColor"),
					getCookie("FusenUpdateIsVideo"),getCookie("FusenUpdatePageTitle"));
			} 
			else if (update = "Del") {
				deleteTag(getCookie("FusenUpdatePageID"),getCookie("FusenUpdateTagID"));
			}
			delFusenUpdateToCookie(n);
		}
	}
}



function addNewTag(pageId, tagId, in_text, color, isVideo, pageTitle)
{
	var pageTagsDiv = document.getElementById(pageId + "Tags");
	if (pageTagsDiv == null) {
		addNewTagWithNewPage(pageId, tagId, in_text, color, isVideo, pageTitle);
		return;
	}
	var linkto = "adica:fusen_res/" + pageId + "/" + tagId;
	var newElement = document.createElement("<div onclick='linkTo(\"" + linkto + "\");' id='" + pageId + tagId + "' style=\"cursor:hand;\">");

	var imgpath = BASERESOURCE + "../image_icon.gif";
	if (isVideo == "true") {
		imgpath = BASERESOURCE + "../video_icon.gif";
	}

	newElement.innerHTML = "<table><tr>" + 
							"<td><img src='" + imgpath + "'></td>" + 
							"<td style='background-color:" + color + ";font-size:12;width:100%;' >" + 
							"<img src ='" + BASERESOURCE + "../tab.gif'>" + in_text + "</td>" + 
							"</tr></table>";

	var previousTag = document.getElementById(pageId + tagId);
	if (previousTag) {
		var rep = pageTagsDiv.replaceChild(newElement,previousTag);
	} else {
		pageTagsDiv.appendChild(newElement);
	}

}



function addNewTagWithNewPage(pageId, tagId, text, color, isVideo, pageTitle)
{
	var allTagsDiv = document.getElementById("allTags");
	if (allTagsDiv == null) {
		return;
	}
	var newElement = document.createElement("<div id='" + pageId + "TagInfo'>");
	allTagsDiv.appendChild(newElement);

	var linkto = "adica:fusen_res/" + pageId + "/" + tagId;

	var imgpath = BASERESOURCE + "../image_icon.gif";
	if (isVideo == "true") {
		imgpath = BASERESOURCE + "../video_icon.gif";
	}

	newElement.innerHTML = "<li id='nonfoldheader' style='color:white;'><img src='" + BASERESOURCE + "../closebook.gif' id='folderType1'/>" + pageTitle + "</li>" + 
				"<ul id='foldinglist'  style='display:block'>" + 
					"<div id='" + pageId + "Tags'>" +
					"<div onclick='linkTo(\"" + linkto + "\");' id='" + pageId + tagId + "' style=\"cursor:hand;\">" + 
					"<table><tr>" + 
						"<td><img src='" + imgpath + "'></td>" + 
						"<td style='background-color:" + color + ";font-size:12;width:100%;' >" +
						"<img src ='" + BASERESOURCE + "../tab.gif'>" + text + "</td>" + 
					"</tr></table></div></div></ul>";
}


function deleteTag(pageId, tagId)
{
	var delDiv = document.getElementById(pageId + tagId);
	if(delDiv) {
		delDiv.removeNode(true);
	}
}


function getFusenLockFromCookie() {
	return getCookie("FusenLock");
}


function getFusenUpdateFromCookie(n) 
{
	var cookieID = "FusenUpdate_" + MANUAL_NAME + "_tag" + n;
	var cookieValue = getCookie(cookieID);
	return cookieValue;
}

function delFusenUpdateToCookie(n) 
{
	var cookieID = "FusenUpdate_" + MANUAL_NAME + "_tag" + n;
	setCookie(cookieID, "", "")
	return;
}

function setFusenUpdateToCookie() {
	return setCookie("FusenUpdate", "", "");
}


function linkTo(href) {
	location.href=href;
}

function setBaseResource(str) {
	BASERESOURCE = str;
}

function setManualName(filename) {
	MANUAL_NAME = filename;
}


